<?php
/*
 Plugin Name: EventON - Countdown timer
 Plugin URI: http://www.myeventon.com/
 Description: Count down till the event ends
 Author: Ashan Jay
 Version: 0.4
 Author URI: http://www.ashanjay.com/
 Requires at least: 3.8
 Tested up to: 4.8

 */

 class eventon_cd{
 	public $version='0.4';
	public $eventon_version = '2.6';
	public $name = 'Countdown';
	public $id = 'EVOCD';

	public $print_scripts_on = false;

	// Instanace
		protected static $_instance = null;
		public static function instance() {
			if ( is_null( self::$_instance ) ) {
				self::$_instance = new self();
			}
			return self::$_instance;
		}

 	// Construct
	public function __construct(){
		$this->super_init();
		add_action('plugins_loaded', array($this, 'plugin_init'));
	}

	function plugin_init(){
		if(class_exists('EventON')){
			include_once( 'includes/admin/class-admin_check.php' );
			$this->check = new addon_check($this->addon_data);
			$check = $this->check->initial_check();
			
			if($check){
				// initiate eventon addon
				$this->addon = new evo_addon($this->addon_data);

				$this->helper = new evo_helper();

				add_action( 'init', array( $this, 'init' ), 0 );
				// settings link in plugins page
				add_filter("plugin_action_links_".$this->plugin_slug, array($this,'plugin_links' ));
			}
		}else{
			add_action('admin_notices', array($this, '_eventon_warning'));
		}
	}
	function _eventon_warning(){
		?><div class="message error"><p><?php _e('EventON is required for this addon to work properly.', 'eventon'); ?></p></div><?php
	}
	
	// SUPER init
		function super_init(){
			// PLUGIN SLUGS			
			$this->addon_data['plugin_url'] = path_join(WP_PLUGIN_URL, basename(dirname(__FILE__)));
			$this->addon_data['plugin_slug'] = plugin_basename(__FILE__);
			list ($t1, $t2) = explode('/', $this->addon_data['plugin_slug'] );
	        $this->addon_data['slug'] = $t1;
	        $this->addon_data['plugin_path'] = dirname( __FILE__ );
	        $this->addon_data['evo_version'] = $this->eventon_version;
	        $this->addon_data['version'] = $this->version;
	        $this->addon_data['name'] = $this->name;

	        $this->plugin_url = $this->addon_data['plugin_url'];
	        $this->plugin_slug = $this->addon_data['plugin_slug'];
	        $this->slug = $this->addon_data['slug'];
	        $this->plugin_path = $this->addon_data['plugin_path'];
		}

	// INITIATE please
		function init(){				
			// Activation
			$this->addon->activate();	
			
			// Deactivation
			register_deactivation_hook( __FILE__, array($this,'deactivate'));

			include_once($this->plugin_path.'/includes/class-shortcodes.php');
			include_once($this->plugin_path.'/includes/class-frontend.php');

			$this->frontend = new evocd_front();

			// RUN addon updater only in dedicated pages
			if ( is_admin() ){
				include_once($this->plugin_path.'/includes/admin/class-admin-init.php');
				$this->admin = new evocd_admin();
			}

			//AJAX includes
			if ( defined('DOING_AJAX') ){
				//include_once($this->plugin_path.'/includes/class-ajax.php');
			}	
	
		}
	
	
 	// Deactivate addon
		function deactivate(){
			$this->addon->remove_addon();
		}

	// plugin link in settings
		function plugin_links($links){
			$settings_link = '<a href="admin.php?page=eventon&tab=evcal_cd">'.__('Settings','eventon').'</a>'; 
			array_unshift($links, $settings_link); 
	 		return $links; 	
		}
	// language
		public function lang($variable, $default_text, $lang=''){
			return eventon_get_custom_language($this->frontend->evoOpt2, $variable, $default_text, $lang);
		}
		
 }

// Initiate this addon within the plugin
function EVOCD(){
	return eventon_cd::instance();
}
$GLOBALS['eventon_cd'] = EVOCD();