<?php
/**
 * DailyView front-end
 * @version 	1.0.5
 * @updated 	2017-2
 */

class evodv_frontend{

	public $print_scripts_on;
	public $day_names = array();
	public $focus_day_data= array();
	public $shortcode_args;

	public $is_running_fc =false;

	function __construct(){
		// scripts and styles 
		add_action( 'init', array( $this, 'register_styles_scripts' ) ,15);	
		add_action( 'wp_footer', array( $this, 'print_dv_scripts' ) ,15);

		// inclusion
		add_action('eventon_calendar_header_content',array($this, 'calendar_header_hook'), 10, 1);
		add_action('evo_addon_styles', array($this, 'styles') );
	}

	// styles for dailyView
		function styles(){
			global $eventon_dv;
			ob_start();
			include_once($eventon_dv->plugin_path.'/assets/dv_styles.css');
			echo ob_get_clean();
		}	
		public function register_styles_scripts(){
			global $eventon_dv, $eventon;
			
			// Load dailyview styles conditionally
			$evOpt = evo_get_options('1');
			if( evo_settings_val('evcal_concat_styles',$evOpt, true))
				wp_register_style( 'evo_dv_styles',$eventon_dv->plugin_url.'/assets/dv_styles.css');

			wp_register_script('evo_dv_mousewheel',$eventon_dv->plugin_url.'/assets/jquery.mousewheel.min.js', array('jquery'), $eventon_dv->version, true );
			//wp_register_script('evodv_other',$eventon_dv->plugin_url.'/assets/jquery.mobile.min.js', array('jquery'), $eventon_dv->version, true );	
			wp_register_script('evo_dv_script',$eventon_dv->plugin_url.'/assets/dv_script.js', array('jquery'), $eventon_dv->version, true );	

			if(function_exists('has_eventon_shortcode') && has_eventon_shortcode('add_eventon_dv')){
				// LOAD JS files
				$this->print_scripts();					
			}
			add_action( 'wp_enqueue_scripts', array($this,'print_styles' ));
				
		}
		public function print_scripts(){
			wp_enqueue_script('evo_dv_mousewheel');
			//wp_enqueue_script('evodv_other');	
			wp_enqueue_script('evo_dv_script');	
		}

		function print_styles(){
			wp_enqueue_style( 'evo_dv_styles');	
		}
		function print_dv_scripts(){	
			global $eventon_dv;
			//if(!$this->print_scripts_on)
			if($eventon_dv->is_running_dv)
				return;

			$this->print_scripts();
			$eventon_dv->is_running_dv=false;
		}

	// add daily view hidden field to calendar header
		function calendar_header_hook($content){
			global $eventon_dv;
			// check if full cal is running on this calendar
			
			if($eventon_dv->is_running_dv){			
				$day_data = $this->focus_day_data;

				$mo1st = (!empty($this->focus_day_data['mo1st']) && $this->focus_day_data['mo1st'] =='yes')? true: false;

				$_cal_focus_day = $mo1st? 1:$this->focus_day_data['day'];				
				$mo1st_class = $mo1st? ' mo1st':null;	// Move to first of month class			

				echo "<input type='hidden' class='eventon_other_vals{$mo1st_class} evoDV' name='dv_focus_day' data-mo1st='".( $mo1st_class? 'yes':'no')."' data-day='".$day_data['day']."' value='".$_cal_focus_day."' />";
				echo "<input type='hidden' class='eventon_other_vals evoDV' name='dv_mo1st' value='".($mo1st?'yes':'no')."'/>";
				echo "<input type='hidden' class='eventon_other_vals evoDV' name='dv_def_focus_day' value='".$this->focus_day_data['day']."'/>";
				

				$this->print_scripts();
			}else{
				wp_dequeue_script('evo_dv_script');
			}
		}

	/**	MAIN Function to generate the calendar outter shell	for daily view */
		public function generate_calendar($args, $type=''){
			global $eventon, $wpdb, $eventon_dv;	

			$this->only_dv_actions($args);	
			
			// Intial variables
				// GET preset values
					$month_incre = (!empty($args['month_incre']))?$args['month_incre']:0;
					$day_incre = (!empty($args['day_incre']))?$args['day_incre']:0;	

				//  *** SET day month and year values for DV
					if(!empty($args['fixed_day']) && $args['fixed_day']!=0 && $args['fixed_month']!=0 && $args['fixed_year']!=0){
						$__date = $args['fixed_day'];
						$__month = $args['fixed_month'];
						$__year = $args['fixed_year'];
					}else{
						// month and year
						if($month_incre !=0){
							$this_month_num = date('n');
							$this_year_num = date('Y');
							
							$mi_int = (int)$month_incre;
							$new_month_num = $this_month_num +$mi_int;
							
							//month
							$__month = ($new_month_num>12)? 
								$new_month_num-12:
								( ($new_month_num<1)?$new_month_num+12:$new_month_num );
							
							// year		
							$__year = ($new_month_num>12)? 
								$this_year_num+1:( ($new_month_num<1)?$this_year_num-1:$this_year_num );

						}else{
							$__month = date_i18n('n');
							$__year = date_i18n('Y');
						}

					$_days_in_month = $this->get_days_in_month($__month, $__year);

					// date
					$today_day = date_i18n('j');

					if(!empty($day_incre) && $day_incre!=0){
						$di_int = (int)$day_incre;
						$new_day = $today_day+$di_int;

						// check if day increment cause to move to next month forward
						if($new_day>$_days_in_month){
							$__date = $new_day -$_days_in_month;
							$__month = $__month+1;
							$__year = ($__month>12)? 
								$__year+1:( ($__month<1)?$__year-1:$__year );

						// if day incre move months back
						}elseif($new_day<1){

							$__month = $__month-1;
							$__month = ($__month<1)? 12: $__month;
							$__year = ($__month<1)? $__year-1: $__year;

							$_days_in_prev_month = $this->get_days_in_month($__month, $__year);

							$__date = $new_day+$_days_in_prev_month;
						}else{
							$__date= $new_day;
						}
					}else{
						$__date = $today_day;
					}
				}

				// DAY RANGES
					$focus_start_date_range = mktime( 0,0,0,$__month,$__date,$__year );
					$focus_end_date_range = mktime(23,59,59,$__month,$__date,$__year);
					$mo1st=( !empty($args['mo1st']) )? $args['mo1st']: '';				
				
				// Set focus day data within the class
					$this->focus_day_data = array(
						'day'=>$__date,
						'month'=>$__month,
						'year'=>$__year,
						'mo1st'=>$mo1st,
						'focus_start_date_range'=>$focus_start_date_range,
						'focus_end_date_range'=>$focus_end_date_range,
						'cal_id'=>((!empty($args['cal_id']))? $args['cal_id']:'1')
					);
					$eventon_dv->is_running_dv=true;
				
				//print_r($this->focus_day_data);
				
				// Add extra arguments to shortcode arguments
					$new_arguments = array(
						'focus_start_date_range'=>$focus_start_date_range,
						'focus_end_date_range'=>$focus_end_date_range,
						'fixed_month'=>$__month,
						'fixed_year'=>$__year,
					);
				
				$args = (!empty($args) && is_array($args))? array_merge($args, $new_arguments): $new_arguments;

				// today title
					if(!empty($args['today']) && $args['today']=='yes' && !empty($args['header_title'])){
						$args['date_header'] = false;
						$args['hide_so'] = 'yes';
					}
			
			// PROCESS variables
			$args__ = $eventon->evo_generator->process_arguments($args);
			$this->shortcode_args=$args__;

			// ==================
			$this->events_list = $eventon->evo_generator->evo_get_wp_events_array('', $args__);
			

			ob_start();

				if($type!='listOnly')
					echo $eventon->evo_generator->get_calendar_header(array(
						'focused_month_num'=>$__month, 
						'focused_year'=>$__year
						)
					);

				// calendar events
					$months_event_array = $eventon->evo_generator->generate_event_data( 
						$this->events_list, $focus_start_date_range, $__month, $__year
					);

					echo $eventon->evo_generator->evo_process_event_list_data($months_event_array, $args);
					if($type!='listOnly')
						echo $eventon->evo_generator->calendar_shell_footer();

			$this->remove_dv_only_actions();
			return  ob_get_clean();	
		}

	// days strip		
		function get_daily_view_list($day, $month, $year, $filters='', $shortcode=''){
			global $eventon;

			$lang = (!empty($shortcode['lang']))? $shortcode['lang']: null;

			$this->set_three_letter_day_names($lang);
			$this->set_full_day_names($lang);

			$number_days_in_month = $this->days_in_month( $month, $year);

			// current month data
				$TODAY = current_time('Y-n-j');
				$TODAY = explode('-', $TODAY);
			
			// calculate date range for the calendar
				date_default_timezone_set('UTC');
				$focus_month_beg_range = mktime( 0,0,0,$month,1,$year );
				$focus_month_end_range = mktime( 23,59,59,$month,$number_days_in_month,$year );
			
			// GET GENERAL shortcode arguments if set class-wide
				$shortcode_args = (!empty($shortcode))? $shortcode: $this->shortcode_args;

			// Update date range to shortcode arguments
				$updated_shortcode_args['focus_start_date_range'] = $focus_month_beg_range;
				$updated_shortcode_args['focus_end_date_range'] = $focus_month_end_range;
				$updated_shortcode_args = array_merge($shortcode_args, $updated_shortcode_args);

				//print_r($updated_shortcode_args);

			// get Events array
				$event_list_array = $eventon->evo_generator->evo_get_wp_events_array('',$updated_shortcode_args, $filters );
			
			// build a month array with days that have events
			$date_with_events= $dates_event_counts = $days_w_e = array();
			if(is_array($event_list_array) && count($event_list_array)>0){
				
				// each event
				foreach($event_list_array as $event){
					$__dur_type = $__duration ='';
					
					// check for all year event
					$_is_all_year = (!empty($event['event_pmv']['evo_year_long']) && $event['event_pmv']['evo_year_long'][0]=='yes')? true:false;	
					// check if month long
					$_is_all_month = $_is_all_year? false: ((!empty($event['event_pmv']['_evo_month_long']) && $event['event_pmv']['_evo_month_long'][0]=='yes')? true:false );

					if($_is_all_year || $_is_all_month){
						$__duration= $number_days_in_month;
						$start_date = 1;
					}else{	
						$start_date = (int)(date('j',$event['event_start_unix']));
						$start_month = (int)(date('n',$event['event_start_unix']));
						
						$end_date = (int)(date('j',$event['event_end_unix']));
						$end_month = (int)(date('n',$event['event_end_unix']));	

						$__duration='0';
						// same month
						if($start_month == $end_month){
							// same date
							if($start_date == $end_date){
								$__no_events = (!empty($dates_event_counts[$start_date]))?
										$dates_event_counts[$start_date]:0;
									
								$dates_event_counts[$start_date] = $__no_events+1;

								$date_with_events[$start_date] = $start_date;
								$days_w_e[$start_date]['et'][] = $event['event_title'];
								$days_w_e[$start_date]['ec'][] = (!empty($event['event_pmv']['evcal_event_color'])? 
									$event['event_pmv']['evcal_event_color'][0]:'');
							}else if($start_date<$end_date){
							// different date
								$__duration = $end_date - $start_date+1;						
							}
						}else{
							// different month
							// start on this month
							if($start_month == $month){
								$__duration = $number_days_in_month - $start_date +1;			
								$__dur_type = ($__duration==0)? 'eom':'';
							}else{
								if( $end_month != $month){
									// end on next month
									$start_date=1;
									$__duration = $number_days_in_month;
								}else{
									// start on a past month
									$start_date=1;
									$__duration = ($end_date==1)? 1: $end_date;
								}
							}
						}
					}

					// run multi-day
					if(!empty($__duration)  || $__dur_type=='eom'){
						$__duration = ($__duration==0 && $__dur_type=='eom')? 1: $__duration;
						for($x=0; $x<$__duration; $x++){
							if( $number_days_in_month >= ($start_date+$x) )
								$__this_date = (int)$start_date + $x;
								//echo $__this_date.'*'.$start_date.'-'.$__duration.'&'.$x.' ';
								
								$__no_events = (!empty($dates_event_counts[$__this_date]))?
									(int)$dates_event_counts[$__this_date]:0;

								$dates_event_counts[$__this_date] = $__no_events+1;
								$date_with_events[$start_date+$x] = $start_date+$x;
								$days_w_e[$__this_date]['et'][] = $event['event_title'];
								$days_w_e[$__this_date]['ec'][] = (!empty($event['event_pmv']['evcal_event_color'])? 
									$event['event_pmv']['evcal_event_color'][0]:'');
						}
					}
				}
			}	
			
			//ob_start();
			$__focus_day = ($day >$number_days_in_month)? $number_days_in_month: $day;

			$output='';

			for($x=0; $x<$number_days_in_month; $x++){
				$day_classes = array();

				$day_of_week = date('N',strtotime($year.'-'.$month.'-'.($x+1)));
				
				// class name additions
					if(is_array($date_with_events) && count($date_with_events)>0){
						if(in_array($x+1, $date_with_events))
							$day_classes[] = 'has_events';
					}				
					if($__focus_day==($x+1)) $day_classes[] = 'on_focus';
					if($x+1 < $__focus_day)	$day_classes[] ='past_day';
					if( $x+1 == $__focus_day) $day_classes[] ='focused';
					if( $x+1 == $TODAY[2] && $year == $TODAY[0] && $month == $TODAY[1]) 
						$day_classes[] ='today';
					

				// number of events for that day
				$daysEventCount = 0;
				if(!empty($dates_event_counts[$x+1])){
					$daysEventCount = ($dates_event_counts[$x+1]==1)? (int)$dates_event_counts[$x+1]: (int)$dates_event_counts[$x+1];
					$__events = 'data-events="'.$daysEventCount.'"';
				}else{$__events ='data-events="0"';}

				// data  full length day name
				$day_name = 'data-dnm="'.$this->full_day_names[$day_of_week].'"';

				// json array
				$json = (array_key_exists($x+1, $days_w_e))? ($days_w_e[$x+1]): null;

				// days event count elements
					$innerItems = '';
					if($daysEventCount>0){
						switch($daysEventCount){
							case 1: $innerItems= "<em data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em>"; break;
							case 2: $innerItems= "<em data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em><em data-title='".$json['et'][1]."' style='background-color:#{$json['ec'][1]}'></em>"; break;
							case 3: $innerItems= "<em data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em>
								<em data-title='".$json['et'][1]."' style='background-color:#{$json['ec'][1]}'></em>
								<em data-title='".$json['et'][2]."' style='background-color:#{$json['ec'][2]}'></em>"; break;
							case ($daysEventCount>3): $innerItems= "<em class='more' data-title='".$daysEventCount."+'></em>"; break;
						}
					}				

				$output.= "<p class='evo_day ".implode(' ', $day_classes)."' {$__events} {$day_name} data-date='".($x+1)."' data-cdate='". ( $year.'-'.$month.'-'.($x+1))."'>
						<span class='evo_day_name'>".$this->day_names[$day_of_week]."</span>
						<span class='evo_day_num'>".($x+1)."</span>
						<span class='evoday_events'>".$innerItems."</span>
					</p>";
			}
			//$output.= "<div class='clear'></div>";
			
			return $output;
			//return ob_get_clean();
		}
		
	//	create the content for the days 
		function content_below_sortbar_this($content,$args=''){
			global $eventon_dv;
			// check if daily view is running on this calendar
			if(!$eventon_dv->is_running_dv)
				return;
				
			$day_data = $this->focus_day_data;
			$evcal_val1= get_option('evcal_options_evcal_1');

			$this->set_three_letter_day_names();
			$this->set_full_day_names();

			//print_r($day_data);

			// DAILY VIEW section
			$dv_strip_margin = (( ($day_data['day'])*(-60) )+130 ).'px';
			$hide_arrows = ($evcal_val1['evcal_arrow_hide']=='yes')? true:false;
			

			// current date section
			$day_of_week = date('N', $day_data['focus_start_date_range']);
			$dayname = $this->get_full_day_names($day_of_week);

			// top date box
			if(!empty($this->shortcode_args['hide_date_box']) && $this->shortcode_args['hide_date_box']!='yes'){

				$number_days_in_month = $this->days_in_month( $day_data['month'], $day_data['year']);

				$content.="<div class='evodv_current_day'>
					<p class='evodv_dayname'>{$dayname}</p>
					<p class='evodv_daynum'><span class='evodv_daynum_switch prev' data-dir='prev'><i class='fa fa-angle-left'></i></span><b>{$day_data['day']}</b><span class='evodv_daynum_switch next' data-dir='next'><i class='fa fa-angle-right'></i></span></p>
					<p class='evodv_events' style='display:none'><span>2</span>". eventon_get_custom_language('', 'evcal_lang_events','Events' )."</p>
				</div>";
			}

			$content.="
			<div class='eventon_daily_list ".( (!$hide_arrows)? 'dvlist_hasarrows': 'dvlist_noarrows' )."' data-fday='".($day_data['day'])."' data-mdays='".$number_days_in_month."' data-mo1st='".$args['mo1st']."'>
				<div class='eventon_dv_outter'>
					<span class='evodv_action prev'></span>
					<div class='eventon_daily_in' data-left='{$dv_strip_margin}' style='left:{}'>";	
						
						$content .= $this->get_daily_view_list($day_data['day'],$day_data['month'], $day_data['year']);
						//$content .= $this->get_daily_view_list($day_data['day'],$day_data['month']+1, $day_data['year']);
						
					$content .="</div>
					<span class='evodv_action next'></span>
				</div>
			</div>";

			//$content.= "<div class='evodv_carousel'><div class='inner'>".$this->get_daily_view_list($day_data['day'],$day_data['month'], $day_data['year']) . "</div></div>";
			
			echo $content;
			
			// Stop this from being getting attached to other calendars.
			remove_action('eventon_after_loadbar',array( $this, 'content_below_sortbar_this' ));
		}

	// other supported functions
		function get_days_in_month($month, $year){
			if(function_exists('cal_days_in_month')){
				return cal_days_in_month(CAL_GREGORIAN,$month, $year);
			}else{
				return date('t', mktime(0, 0, 0, $month+1, 0, $year)); 
			}
		}

		public function only_dv_actions($args){
			$this->shortcode_args = $args;
			if(empty($args['today']) || (!empty($args['today']) && $args['today']!='yes'))
				add_action('eventon_after_loadbar',array( $this, 'content_below_sortbar_this' ), 10,2);
			add_filter('eventon_cal_class', array($this, 'eventon_cal_class'), 10, 1);			
		}

		public function remove_dv_only_actions(){
			remove_filter('eventon_cal_class', array($this, 'eventon_cal_class'));	
		}

		// add class name to calendar header for DV
			function eventon_cal_class($name){
				if(!empty($this->shortcode_args['today']) && $this->shortcode_args['today']=='yes')
					$name[]='evoDVtoday';
				$name[]='evoDV';
				return $name;
			}

		// three letter day array
			function set_three_letter_day_names($lang=''){				
				// Build 3 letter day name array to use in the fullcal from custom language
				for($x=1; $x<8; $x++){			
					$evcal_day_is[$x] =eventon_return_timely_names_('day_num_to_name',$x, 'three', $lang);
				}					
				$this->day_names = $evcal_day_is;
			}

		// full length day array
			function set_full_day_names($lang=''){				
				// Build 3 letter day name array to use in the fullcal from custom language
				for($x=1; $x<8; $x++){			
					$evcal_full_day_is[$x] =eventon_return_timely_names_('day_num_to_name',$x, 'full', $lang);		
				}					
				$this->full_day_names = $evcal_full_day_is;
			}

		// full length day array
			function get_full_day_names($dayofweekN, $lang=''){						
				return eventon_return_timely_names_('day_num_to_name',$dayofweekN, 'full', $lang);	
			}
		function days_in_month($month, $year) { 
			return date('t', mktime(0, 0, 0, $month+1, 0, $year)); 
		}
}
