/**
 * Javascript: Seats Admin scripts
 * @version  0.1
 */
jQuery(document).ready(function($){	

	draggableStuff();	
	function draggableStuff(){
		$('.evost_section').draggable({
			handle:'em',
			containment: $('.evosteditor_content')
		});
	}

	// When seat map editor is opened from backend post
		$('.evost_open_seat_map_editor').on('click',function(){
			OBJ = $(this);
			var ajaxdataa = {};
			ajaxdataa['action']='get_seat_map_html';
			ajaxdataa['eventid'] = OBJ .data('eid');
			ajaxdataa['product_id'] = OBJ.data('product_id');
			
			$.ajax({
				beforeSend: function(){ $('.evost_lightbox .ajde_popup_text').addClass('loading');	},					
				url:	evost_admin_ajax_script.ajaxurl,
				data: 	ajaxdataa,	dataType:'json', type: 	'POST',
				success:function(data){
					if(data.status=='good'){
						$('.evost_lightbox').find('.evost_sections_container').html( data.content );
						draggableStuff();
					}else{}
				},complete:function(){ $('.evost_lightbox .ajde_popup_text').removeClass('loading');	}
			});
		});

	// add and remove seat row fields to form
		$('.evost_lightbox').on('click','.evost_row_actions .add',function(event){
			event.stopPropagation();
			SECTION = $(this).closest('.formsin');
			i = (parseInt(SECTION.find('.evost_rowfield').length))+1;
			ROW = "<p class='evost_rowfield'><label>Row " + i + "</label><span><em>Seat Count</em><input type='number' name='[r"+i+"][seats]'></span><span><em>Price</em><input type='number' name='[r"+i+"][row_price]'></span><span><em>Index</em><input type='text' name='[r"+i+"][row_index]'></span><i>x</i></p>";
			SECTION.find('.evost_row_fields').append(ROW);
		})

		// remove a row
		$('.evost_lightbox').on('click','.evost_row_fields i',function(event){
			$(this).parent().remove();
		});
	
	// Open add new sections
		$('.evost_lightbox').on('click','.trig_new_section',function(){
			BOX = $(this).closest('.ajde_popup_text');
			BOX.find('.evost_new_section_form').show();
			BOX.find('.evost_forms').addClass('show');
		});
	// close any form
		$('.evost_lightbox').on('click','.evost_forms .evost_close',function(event){
			event.preventDefault;
			event.stopPropagation();

			OBJ = $(this);
			BOX = $(this).closest('.ajde_popup_text');
			FORM = $(this).parent();
			FORM.hide();

			// closing edit seat form
			if(OBJ.parent().hasClass('evost_edit_seat_form')){				
				$('.evost_sections_container').find('.seat').removeClass('editing');
			}

			// disable editing seats
			if(FORM.hasClass('evost_edit_seat_form')){
				$('.evost_sections_container').find('li.seat').removeClass('editing');
			}
		});

	// selecting nonassign seating
		$('.ajde_lightbox_outter').on('click','#unassigned',function(){
			OBJ = $(this);
			FORMS = OBJ.closest('.evost_new_section_form');
			if(OBJ.hasClass('NO')){
				FORMS.addClass('unassigned');
				OBJ.parent().siblings('.unassigned_data').show();
				OBJ.parent().siblings('.evost_row_fields').hide();
			}else{
				FORMS.removeClass('unassigned');
				OBJ.parent().siblings('.unassigned_data').hide();
				OBJ.parent().siblings('.evost_row_fields').show();
			}
		});

	// SECTION
		// selecting a section for editing
		$('.evost_lightbox').on('click','.evosteditor_content',function(event){
			event.stopPropagation();
			if($(this).hasClass('editing')){
				// hiding
				if(!$(event.target).is('.evost_section.editing') && 
					$(event.target).closest('.evost_section.editing').length ==0 &&
					!$(event.target).is('.evost_section_actions i') 
				){
				    $(this).removeClass('editing');
					$(this).find('.evost_section').removeClass('editing');
					$('body').find('.evost_close').trigger('click');
				}
			}else{
				//showing
				if($(event.target).closest('.evost_section').length >0) {
					SECTION = $(event.target).closest('.evost_section');
					// location of section actions
					sectiontop = parseInt(SECTION.css('top'));
					height = $('.evosteditor_content').height();

					additionalClass = (sectiontop+100 > height)?'top':'';

					
					SECTION.addClass('editing');
					SECTION_NAME = SECTION.attr('data-name');
					SECTION.parent().siblings('.evost_section_actions').attr('class','evost_section_actions '+additionalClass);
					SECTION.parent().siblings('.evost_section_actions').find('span').html(SECTION_NAME);
					$(this).addClass('editing');
				}				
			}
		});

		// submit the add new/edit SECTION form
			$('.evost_lightbox').on('click','.evost_new_section_btn',function(event){
				event.stopPropagation();

				OBJ = $(this);
				FORM = OBJ.closest('.formsin');

				FORMTYPE = OBJ.hasClass('save')? 'edit':'new';
				SECTION_TYPE = FORM.hasClass('unassigned')? 'unassigned':'seats'; // beta

				error = 0;
				DATA = {};
				FORM.find('input').each(function(){
					VAL = $(this).val();
					if($(this).hasClass('req') && ( VAL === undefined || VAL == '') ) error++;
					DATA[ $(this).attr('name')] = VAL;
				});


				if(error ==0 ){
					SECTIONS = parseInt($('.evost_sections_container').find('.evost_section').length);	
					SECTION_index = SECTIONS+1;
						if($('.evost_sections_container').find('#evost_section_'+SECTION_index).length>0)
							SECTION_index = SECTION_index+1;

					// if editing a section 
					if(FORMTYPE == 'edit')	SECTION_index = OBJ.attr('data-section_index');

					var ajaxdataa = {};
						ajaxdataa['action']='save_section_output';
						ajaxdataa['index']=SECTION_index;
						ajaxdataa['data']=DATA;
						ajaxdataa['formtype']=FORMTYPE;
						ajaxdataa['section_type']=SECTION_TYPE;
						ajaxdataa['ang']	= OBJ.data('ang');

						// if edit form
							if(FORMTYPE=='edit'){
								SECTION = $('.evost_sections_container').find('#evost_section_'+SECTION_index);
								ajaxdataa['fdata'] = get_section_data(SECTION);
								ajaxdataa['top'] = OBJ.attr('data-section_top');
								ajaxdataa['left'] = OBJ.attr('data-section_left');
							}

						$.ajax({
							beforeSend: function(){	FORM.closest('.ajde_popup_text').addClass('loading');	},
							type: 	'POST',
							url: 	evost_admin_ajax_script.ajaxurl,
							data: 	ajaxdataa,
							dataType:'json',
							success:function(data){

								if(FORMTYPE=='edit'){
									$('.evost_sections_container').find('#evost_section_'+SECTION_index).replaceWith(data.content);
								}else{
									$('.evost_sections_container').append(data.content);
								}
								
								draggableStuff();
								FORM.slideUp(function(){
									FORM.html(data.newform);
								});
							},complete:function(){
								FORM.closest('.ajde_popup_text').removeClass('loading');
							}
						});

				}else{
					show_msg('Required Fields Missing', 'bad');
				}
			});
		
		// Delete Section
			$('.evost_section_actions').on('click','i.fa-trash',function(){
				$(this).parent().siblings('.evost_sections_container').find('.evost_section.editing').remove();
				$('.evosteditor_content').removeClass('editing');
			});
		// Edit Section
			$('.evost_section_actions').on('click','i.fa-pencil',function(){
				SECTION = $(this).parent().siblings('.evost_sections_container').find('.evost_section.editing');
				
				SECTION_form = $('.evost_edit_section_form');
							
				sectiondata = get_section_data(SECTION);

				var ajaxdataa = {};
				ajaxdataa['action']='get_edit_section';
				ajaxdataa['data']=sectiondata;
				$.ajax({
					beforeSend: function(){	SECTION.closest('.ajde_popup_text').addClass('loading');	},
					type: 'POST',
					url:evost_admin_ajax_script.ajaxurl,
					data: ajaxdataa,
					dataType:'json',
					success:function(data){
						SECTION_form.html(data.content);
						SECTION_form.slideDown();
						SECTION_form.parent().addClass('show');
					},complete:function(){
						SECTION.closest('.ajde_popup_text').removeClass('loading');
					}
				});
			});

	// Get array of data for a single section
		function get_section_data(section){
			var data = {};
			
			position = section.position();
			data = {
				'section_name':section.data('name'),
				'section_index':section.data('index'),
				'top': parseInt(section.css('top')),
				'left': parseInt(section.css('left')),
				'ang': parseInt(section.attr('data-ang')),
			}

			rowcount = 0;
			rows = 'rows';
			data[rows] = {};
			section.find('.evost_row').each(function(indexy){
				indexy = indexy+1;
				data[rows][indexy] = {
					'row_index':$(this).data('index'),
					'row_price':$(this).data('price')
				}
				
				$(this).find('.seat').each(function(indexz){
					indexz = indexz +1;
					data[rows][indexy][indexz] = {
						'id':$(this).attr('id'),
						'number':$(this).attr('data-snumber'),
						'price':$(this).attr('data-price'),
						'status': ($(this).hasClass('uav')?'uav': ( $(this).hasClass('res')?'res':'av')), 
						// available or unavailable or reserved
						'handicap': ($(this).hasClass('hand')?'yes':'no'), // accessible
					}
				});
				rowcount++;
			});
			data['row_count']= rowcount;

			return data;
		}

	// Rotate seat section
		$('.evost_section_actions').on('click','.fa-undo',function(){
			SECTION = $(this).parent().siblings('.evost_sections_container').find('.evost_section.editing');

			current_angle = parseInt(SECTION.attr('data-ang'));
			current_angle = (current_angle % 15 == 0)? current_angle: 0; // check current angle for multiple of 45 degrees
			new_angle = (current_angle<360)? current_angle+15: 0;
			SECTION.attr('data-ang', new_angle);

			SECTION.attr('class','evost_section editing turn'+new_angle);

		});
		$('.evost_section_actions').on('click','.fa-rotate-right',function(){
			SECTION = $(this).parent().siblings('.evost_sections_container').find('.evost_section.editing');

			current_angle = parseInt(SECTION.attr('data-ang'));
			current_angle = (current_angle % 15 == 0)? current_angle: 0; // check current angle for multiple of 45 degrees
			new_angle = (current_angle <= 0)? 360-15: current_angle-15;
			SECTION.attr('data-ang', new_angle);

			SECTION.attr('class','evost_section editing turn'+new_angle);

		});

	// SEAT
		// Edit a seat #edit-seat
			$('.evost_sections_container').on('click','.evost_section.editing .seat',function(){
				FORM = $('.evost_edit_seat_form');
				SEAT = $(this);

				// hide other forms
				FORM.parent().find('.formsin').hide();

				FORM.slideDown();
				FORM.find('input').each(function(index){ 
					VAL = SEAT.attr( 'data-'+$(this).attr('name') );
					if(VAL != ''){
						$(this).val( VAL);
					}
				});

				// seat index
					FORM.attr('data-seat', SEAT.attr('id'));
					$('.evost_sections_container').find('.seat').removeClass('editing');
					SEAT.addClass('editing');

				// available or no
					if(SEAT.hasClass('uav'))	FORM.find('select[name="status"]').val( 'uav');
					if(SEAT.hasClass('res'))	FORM.find('select[name="status"]').val( 'res');
					if(!SEAT.hasClass('uav') && !SEAT.hasClass('res'))	FORM.find('select[name="status"]').val( 'av');
				
				// seat with orders in them
					if( SEAT.attr('data-orderid') != '' && SEAT.attr('data-orderid')!== undefined){
						LINK = FORM.find('p.seat_status a').attr('data-link');
						FORM.find('p.seat_status a')
							.attr('href', LINK+'post.php?post='+ SEAT.attr('data-orderid')+'&action=edit')
							.html(SEAT.attr('data-orderid'));
						FORM.find('p.seat_status span').show();
					}else{
						FORM.find('p.seat_status span').hide();
					}

				// accessibility
					if(SEAT.hasClass('hand')){
						FORM.find('.ajde_yn_btn').removeClass('NO');
						FORM.find('input[name="handicap"]').val('yes');
					}else{
						FORM.find('.ajde_yn_btn').addClass('NO');
						FORM.find('input[name="handicap"]').val('no');
					}

				$('#evost_close').show();
			});
			
			// update seat data #update-seat
			$('.evost_update_seat_btn').on('click',function(){
				OBJ = $(this);
				FORM = OBJ.closest('.formsin');

				error = 0;
				DATA = {};
				FORM.find('.field').each(function(){
					VAL = $(this).val();
					if($(this).hasClass('req'))
						if( VAL === undefined || VAL == '') error++;
					DATA[ $(this).attr('name')] = VAL;
				});

				// accessible
					DATA['handicap'] = FORM.find('input[name="handicap"]').val();

				//console.log(DATA);
				if(error ==0 ){
					SEAT = $('#'+FORM.attr('data-seat'));
					$.each(DATA,function(index, value){
						if(SEAT[0].hasAttribute('data-'+index) )
							SEAT.attr('data-'+index, value);

						if( index== 'status' )	SEAT.attr('class', 'seat '+value);
						if( index== 'handicap' && value=='yes'){
							SEAT.addClass('hand');
						}else{
							SEAT.removeClass('hand');
						}
					});

					FORM.slideUp(function(){
						FORM.find('input').val('');
						SEAT.removeClass('editing');
						$('#evost_close').hide();
					});

				}else{
					show_msg('Required Fields Missing', 'bad');
				}
			});

	// save table selection
		$('body').on('click','.evost_save_seating_changes',function(){
			OBJ = $(this);
			SEATINGS = OBJ.closest('.ajde_lightbox_outter').find('.evost_sections_container');
			SETTINGS = OBJ.closest('.ajde_lightbox_outter').find('.evost_settings');
			
			/*var ajaxdataa = {};
			ajaxdataa['data'] = {};

			// each table
			ajaxdataa['sections'] = {};
			count = 1;
			SEATINGS.find('.evost_section').each(function(index){
				index = $(this).data('index');
				ajaxdataa['sections'][index] = get_section_data($(this));
				count ++;
			});*/

			Sections_count = SEATINGS.find('.evost_section').size();
			save_section_attime( 1, Sections_count, OBJ, SETTINGS );

			// show start of saving process message
			MSG = $('.evost_msg');
			MSG.hide().html( 'Saving Sections!' ).removeClass('error').show();
			
		});
		
		function save_section_attime(index, total, OBJ, SETTINGS ){
			
			if(index > total) return false;

			section_item = OBJ.closest('.ajde_lightbox_outter').find('.evost_section').eq(index-1);

			if(section_item.length == 0) return false;

			section_index = parseInt(section_item.attr('data-index'));

			var ajaxdataa = {};
			ajaxdataa['sections'] = {};
			ajaxdataa['sections'][section_index] = get_section_data( section_item );
			ajaxdataa['action']='save_seating';
			ajaxdataa['e_id']= OBJ.data('eid');
			ajaxdataa['product_id']= OBJ.data('product_id');
			ajaxdataa['seat_bg_img_id']= SETTINGS.find('.evost_seat_bg_img_id').val();
			ajaxdataa['map_area']= SETTINGS.find('select[name="_evost_map_area"]').val();
			ajaxdataa['seat_size']= SETTINGS.find('select[name="_evost_seat_size"]').val();
			ajaxdataa['section_loop_index']= index;
			
			$.ajax({
				beforeSend: function(){	OBJ.closest('.ajde_popup_text').addClass('loading');	},
				type: 'POST',
				url:evost_admin_ajax_script.ajaxurl,
				data: ajaxdataa,
				dataType:'json',
				success:function(data){
					if(data.status=='good'){
						$('.evost_msg').html('Seating info updated for section '+ index +'!');
					}else{
						$('.evost_msg').html('Could not save data correct for section '+ index +'!');
					}

					if(index <= total ){
						save_section_attime( (index+1), total, OBJ, SETTINGS )
					}
					// last section
					if(index == total){
						OBJ.closest('.ajde_popup_text').removeClass('loading');
						$('.evost_msg').html('Saving sections completed!').show(0).delay(3000).hide(0);
					}

				},complete:function(data){
					//show_msg(data.responseText, 'bad');
					//OBJ.closest('.ajde_popup_text').removeClass('loading');					
				}
			});	
		}

	// SETTINGS
		// toggle
			$('.ajde_lightbox_outter').on('click','.evost_settings_btn',function(){
				$(this).closest('.ajde_popup_text').find('.evost_settings').slideToggle();
			});
		// select background image
		var file_frame,
			BOX;
	  
	    $('body').on('click','.evost_select_image ',function(event) {
	    	var obj = jQuery(this);
	    	BOX = obj.closest('.ajde_popup_text');

	    	IMG_URL = '';

	    	// choose image
	    	if(obj.hasClass('chooseimg')){

	    		event.preventDefault();

				// If the media frame already exists, reopen it.
				if ( file_frame ) {
					file_frame.open();
					return;
				}
				// Create the media frame.
				file_frame = wp.media.frames.downloadable_file = wp.media({
					title: 'Choose an Image',
					button: {text: 'Use Image',},
					multiple: false
				});

				// When an image is selected, run a callback.
				file_frame.on( 'select', function() {
					attachment = file_frame.state().get('selection').first().toJSON();

					BOX.find('.evost_seat_bg_img_id').val( attachment.id );
					BOX.find('.evosteditor_content').css('background-image', 'url('+attachment.url+')' );
					var old_text = obj.attr('value');
					var new_text = obj.data('txt');

					obj.attr({'value': new_text, 'data-txt': old_text, 'class': 'evost_select_image evo_admin_btn removeimg'});
				});

				// Finally, open the modal.
				file_frame.open();

			}else{
				
				BOX.find('.evost_seat_bg_img_id').val( '' );
		  		BOX.find('.evosteditor_content').css('background-image', '' );

		  		var old_text = obj.attr('value');
				var new_text = obj.attr('data-txt');

				obj.attr({'value': new_text, 'data-txt': old_text, 'class': 'evost_select_image evo_admin_btn chooseimg'});

				return false;
			}
	    }); 

		// change map area and seat size
			$('.ajde_popup_text').on('change','select.evost_settings_select',function(){
				
				CLASSNAMES = 'ajde_popup evost_lightbox ';
				MA = '';
				$('.ajde_popup_text').find('select.evost_settings_select').each(function(){
					NAME = $(this).data('t');
					CLASSNAMES += NAME + $(this).val() + ' ';
				});

				$('.ajde_popup.evost_lightbox').attr('class',CLASSNAMES);

				draggableStuff();

			});

	// show message
		function show_msg(text, type){
			MSG = $('.evost_msg');
			MSG.hide().html( text ).removeClass('error');
			if(type=='bad'){
				MSG.addClass('error');
			}
			MSG.show(0).delay(3000).hide(0);
		}

});