<?php
/** 
 * EventON Seats admin functions
 */
class EVOST_admin_ajax{
	public function __construct(){
		$ajax_events = array(
			'save_seating'=>'save_seating',
			'get_edit_section'=>'get_edit_section',
			'save_section_output'=>'save_section_output',
			'get_seat_map_html'=>'get_seat_map_html',
		);
		foreach ( $ajax_events as $ajax_event => $class ) {				
			add_action( 'wp_ajax_'.  $ajax_event, array( $this, $class ) );
			add_action( 'wp_ajax_nopriv_'.  $ajax_event, array( $this, $class ) );
		}
	}

	// get seat map HTML
		function get_seat_map_html(){
			global $evost;
			// get updated seat map
			$sections = get_post_meta($_POST['eventid'], '_evost_sections', true);
			$seat_map_section = $evost->fn->get_section_html($sections, 'admin', $_POST['product_id'],$_POST['eventid']);

			echo json_encode(array(
				'content'=>$seat_map_section,
				'status'=> 'good'
			));
			exit;
		}

	// save the sections of seats for an event
		function save_seating(){
			global $evost;

			// save seat values
				if($_POST['section_loop_index']==1){
					update_post_meta($_POST['e_id'], '_evost_sections', $_POST['sections']);
					$seating_sections = $_POST['sections'];
				}else{

					$old_sections = get_post_meta($_POST['e_id'], '_evost_sections', true);

					$seating_sections = (sizeof($old_sections)>0)?
						$_POST['sections'] + $old_sections: 
						$_POST['sections'];

					/*if($_POST['section_loop_index'] == 3){
						print_r($_POST['sections']);
						print_r($seating_sections);
					}*/

					update_post_meta($_POST['e_id'], '_evost_sections', $seating_sections);
				}
				
				
				$total_seats = !empty($_POST['sections'])?$evost->fn->get_total_seats( $seating_sections):0;

			// update ticket seat stock for WC product
				update_post_meta($_POST['product_id'], '_manage_stock','yes');
				update_post_meta($_POST['product_id'], '_stock',$total_seats['av']);

			// save settings
				$evost_settings = array();
				foreach(array('seat_bg_img_id','map_area','seat_size') as $key){
					$evost_settings[$key] = !empty($_POST[$key])?$_POST[$key]:'';
				}
				update_post_meta($_POST['e_id'], '_evost_settings',$evost_settings);
				
			// pluggable functions
				do_action('evost_save_seat_sections', $total_seats);

			echo json_encode(array(
				'status'=>'good',
				'total_seats'=>$total_seats
			));
			exit;
		}

	// get the edit a section form HTML
		function get_edit_section(){
			// /print_r($_POST);
			global $evost;
			
			$section = $_POST['data'];
			
			echo json_encode(array(
				'content'=>$evost->admin->fn->add_new_form_html('edit')
			));
			exit;
		}

	function save_section_output(){
		//print_r($_POST);
		global $evost;

		$rows = count($_POST['data'])-1;
		$name = $_POST['data']['name'];
		$tb_index = $_POST['index'];
		$editForm = (!empty($_POST['formtype']) && $_POST['formtype']=='edit')?true:false;

		$top = !empty($_POST['top'])? $_POST['top'].'px':'10px';
		$left = !empty($_POST['left'])? $_POST['left'].'px':'10px';
		$ang = !empty($_POST['ang'])? $_POST['ang']:0;
		$section_type = !empty($_POST['section_type'])? $_POST['section_type']: 'seats';


		// if edit form
			$override = false;
			if($editForm){
				$rows_data_e = $_POST['fdata']['rows'];
				if(!empty($_POST['data']['override']) && $_POST['data']['override']=='yes')
					$override = true;
			}

		unset($_POST['data']['name']);
		unset($_POST['data']['override']);
		$rows_data = $_POST['data'];

		ob_start();

		// Section Class Name
			$section_class_names = array();
			$section_class_names[] = 'evost_section';
			$section_class_names[] = 'turn'.$ang;
			$section_class_names[] = $editForm?'editing':'';

		?>
		<span id='evost_section_<?php echo $tb_index;?>' class="<?php echo implode(' ', $section_class_names);?>" data-ang='<?php echo $ang;?>' data-index='<?php echo $tb_index;?>' data-rows='<?php echo $rows;?>' data-name='<?php echo $name;?>' style="top:<?php echo $top;?>; left:<?php echo $left;?>">
			<em class='fa fa-bars'></em>
			<u><?php echo $name;?></u>
			<?php 
			$alph = 'A';

			$cc =1;
			foreach($rows_data as $row):

				$index = !empty($row['row_index'])? $row['row_index']: $alph;
				$seats = !empty($row['seats']) ? (int)$row['seats']: 1;
				$price = !empty($row['row_price']) ? $row['row_price']: 0.00;
				$rowe = !empty($rows_data_e[$cc])? $rows_data_e[$cc]:false;
				?>
				<span class="evost_row" data-index='<?php echo $index;?>' data-seats='3' data-price='<?php echo $price;?>'>
					<?php /*<i><?php echo $index;?></i> */?>
					<?php
					for($y=1; $y<= $seats; $y++):

						$sprice = (!$override && $editForm && !empty($rowe[$y]['price']))? 
							$rowe[$y]['price']: $price;
						$status = ( $editForm && !empty($rowe[$y]['status']))? 
							$rowe[$y]['status']:'av';
						$snumber = $index.$y;
						$id = $tb_index.$index.$y;
						$seatid = $tb_index.'-'.$index.'-'.$y;

						$attributes = '';
						foreach(array(
							'id'=> $tb_index.$index.$y,
							'class'=> 'seat '.$status,								
							'data-price'	=> $sprice,
							'data-seatid' 	=> $seatid,
							'data-seat'		=> $y,
							'data-row'		=> $index,
							'data-section'	=> $tb_index,
							'data-snumber'	=> $snumber,
						) as $field=>$val){
							$attributes .= $field .'="'. $val .'"';
						}
					?>
					<span <?php echo $attributes;?>>
						<span class='data'>
							<span>Sec <?php echo $tb_index;?>, Row <?php echo $index;?>, Seat <?php echo $snumber;?></span>
							<span class='price'>
								<span>Ticket Price</span> 
								<span>$<?php echo $sprice;?></span>
							</span>
						</span>
					</span>
					<?php endfor;?>
				</span>
			<?php $cc++; ++$alph; endforeach;?>		
	
		</span>
		<?php

		echo json_encode(array(
			'content'=>ob_get_clean(),
			'newform'=>$evost->admin->fn->add_new_form_html()
		));
		exit;
	}
}
new EVOST_admin_ajax();