<?php
/** 
 * Event Seats Post Meta
 * @version 0.1
 */
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class evost_meta_boxes{
	public function __construct(){
		add_action('evotx_event_metabox_end',array($this, 'event_tickets_metabox'), 10, 4);
		add_filter('evotx_save_eventedit_page',array($this, 'event_ticket_save'), 10, 1);
	}

	// Event Tickets
		function event_tickets_metabox($eventid, $epmv, $wooproduct_id, $product_type){
			global $eventon, $evost;

			//echo $product_type.'yyy';
			// check if simple product with no repeat events data				
			if(!empty($wooproduct_id) && $product_type =='simple' && (empty($epmv['evcal_repeat']) || (!empty($epmv['evcal_repeat']) && $epmv['evcal_repeat'][0] =='no') ) ):

			// Enable setting seat chart for event tickets
				$_enable_seat_chart = evo_meta_yesno($epmv,'_enable_seat_chart','yes','yes','no' );

			// get lightbox content
				$this->lightbox_content($eventid, $epmv, $wooproduct_id, $product_type);
			?>
			<!-- SEATING SECTION -->
				<tr ><td colspan='2'>
					<p class='yesno_leg_line ' >
						<?php echo eventon_html_yesnobtn(array(
							'id'=>'evotx_seating',
							'var'=>$_enable_seat_chart, 
							'attr'=>array('afterstatement'=>'evotx_seat_chart')
						)); ?>
						<input type='hidden' name='_enable_seat_chart' value="<?php echo $_enable_seat_chart;?>"/>
						<label for='_enable_seat_chart'><?php _e('Enable seat charts for this event'); echo $eventon->throw_guide('This will allow you to create seat charts with custom prices per seat to allow customers to buy seat of their choice.','',false)?></label>
					</p>
				</td></tr>
				<tr class='innersection' id='evotx_seat_chart' style='display:<?php echo evo_meta_yesno($epmv,'_enable_seat_chart','yes','','none' );?>'>

					<td style='padding:5px 25px;' colspan='2'>
						<div style='padding:5px 0 9px'>
							<p><?php _e('Set up seat chart with sections', 'eventon'); ?></p>
							<a class='button_evo ajde_popup_trig evost_open_seat_map_editor' data-eid='<?php echo $eventid;?>' data-product_id='<?php echo $wooproduct_id;?>' data-popc='evost_lightbox'><?php _e('Open Seat Map Editor');?></a>
						</div>
					</td>
				</tr>
			<?php

			else:
				?>
				<tr class='' id='evotx_seat_chart' >
					<td style='padding:5px 25px;' colspan='2'>
						<p><i><?php _e('NOTE: Seat Charts are only available for simple ticket product with no repeat instances at the moment. The event ticket basic information must be saved first before adding seat charts.', 'eventon'); ?></i></p>
					</td>

				</tr>
				<?php
			endif;
		}

		// lightbox content for seat map editor
			function lightbox_content($eventid, $epmv, $wooproduct_id, $product_type){
				global $evost, $ajde, $eventon; 

				$SEATSETTINGS = !empty($epmv['_evost_settings'])? unserialize($epmv['_evost_settings'][0]): false;
				$IMG_ID = !empty($SEATSETTINGS['seat_bg_img_id'])? $SEATSETTINGS['seat_bg_img_id']: false;

				// lightbox content
				ob_start();
					?>
					<div class="evosteditor_header">
						<a class='evo_admin_btn trig_new_section'><?php _e('Add new Section','eventon');?></a>
						<a class='evost_settings_btn' title='Seating Settings'><i class="fa fa-cog"></i></a>
					</div>
					<p class="evost_msg" style='display:none'></p>

					<div class="evost_settings" style='display:none'>
						<div class='formsin'>
							<p>
								<label for=""><?php _e('Select background image','eventon');?></label>
								<input type="hidden" class='evost_seat_bg_img_id' name='_evost_seat_bg_img_id' value='<?php echo $IMG_ID? $IMG_ID:'';?>'/>
								<input type="button" class='evost_select_image evo_admin_btn <?php echo $IMG_ID? 'removeimg':'chooseimg';?>' data-txt='<?php echo $IMG_ID?'Select Image':'Remove Image';?>' value='<?php echo $IMG_ID?'Remove Image':'Select Image';?>'/>
								<i class='note'><?php _e('NOTE: You MUST upload an image with matching resolution to the seat map area selected below','eventon');?></i>
							</p>
							<p>
								<label for=""><?php _e('Seat Map Area Size (px)','eventon');?></label>
								<select class='evost_settings_select' data-t='map_area' name="_evost_map_area" id="">
								<?php
									foreach(array(
										'650-350'=>'650 x 350',
										'800-600'=>'800 x 600',
										'900-700'=>'900 x 700',
									) as $index=>$val){
										echo "<option ". ($SEATSETTINGS && !empty($SEATSETTINGS['map_area']) && $SEATSETTINGS['map_area']==$index?'selected="selected"':'') ." value='{$index}'>{$val}</option>";
									}
								?>
								</select>
							</p>
							<p>
								<label for=""><?php _e('Seat Size (px)','eventon');?></label>
								<select class='evost_settings_select' data-t='seat_size' name="_evost_seat_size" id="">
								<?php
									foreach(array(
										'15-15'=>'15 x 15',
										'12-12'=>'12 x 12',
										'10-10'=>'10 x 10',
									) as $index=>$val){
										echo "<option ". ($SEATSETTINGS && !empty($SEATSETTINGS['seat_size']) && $SEATSETTINGS['seat_size']==$index?'selected="selected"':'') ." value='{$index}'>{$val}</option>";
									}
								?>
								</select>
								<i class='note'><?php _e('NOTE: Must save and reload seating to see section width adjusted to new seat size.','eventon');?></i>
							</p>
						</div>
					</div>

					<div class="evost_forms">
						<div class="evost_new_section_form formsin add" style='display:none'>
							<a class="evost_close">X</a>
							<?php echo $evost->admin->fn->add_new_form_html();?>
						</div>
						<div class="evost_edit_section_form formsin edit" style='display:none'>
						</div>
						<div class="evost_edit_seat_form formsin" style='display:none' data-seat=''>
							<a class="evost_close">X</a>
							<h3 class='edit'><?php _e('Edit Seat Information','eventon');?></h3>
							<p><label><?php _e('Seat Number','eventon');?></label><input class='req field' name='snumber' type="text" readonly></p>
							<p><label><?php _e('Price for Seat','eventon');?></label><input class='field' name='price' type="number"></p>
							<p class='seat_status'>
								<label><?php _e('Seat Status','eventon');?></label> <select class='field' name="status">
								<option value="av"><?php _e('Available','eventon');?></option>
								<option value="uav"><?php _e('Unavailable','eventon');?></option>
								<option value="res"><?php _e('Reserved','eventon');?></option>
								</select>
								<span style='display:none'><?php _e('Seat purchased in Order ID:','eventon');?> <a class='evo_admin_btn btn_secondary' href='' data-link='<?php echo get_admin_url();?>'target='_blank'></a></span>
							</p>
							<p class='yesno_leg_line'><?php echo $ajde->wp_admin->html_yesnobtn(array(
								'id'=>'handicap',
								'label'=>__('Handicap Accessible','eventon'),
								'input'=>true
							));?></p>
							<p class=''><a class='evo_admin_btn btn_prime evost_update_seat_btn'><?php _e('Update Seat','eventon');?></a></p>
						</div>
					</div>
					<?php

						// image
						$img = !empty($SEATSETTINGS['seat_bg_img_id'])? wp_get_attachment_image_src($SEATSETTINGS['seat_bg_img_id'], 'full'): false;
					?>
					<div class="evosteditor_content" <?php echo $img? 'style="background-image:url('.$img[0].')"':'';?>>
						<div class="evost_in evost_sections_container" >
						<?php
							if(!empty($epmv['_evost_sections'])){
								$sections = unserialize($epmv['_evost_sections'][0]);
								echo $evost->fn->get_section_html($sections,'admin', $wooproduct_id, $eventid);
							}else{
								//echo '***';
							}
						?>
							
						</div>
						<div class="evost_section_actions" >
							<span></span>
							<i title='<?php _e('Edit Section','eventon');?>' class="fa fa-pencil"></i>
							<i title='<?php _e('Delete Section','eventon');?>' class="fa fa-trash"></i>
							<i title='<?php _e('Rotate Counterclockwise','eventon');?>' class="fa fa-undo"></i>
							<i title='<?php _e('Rotate Clockwise','eventon');?>' class="fa fa-rotate-right"></i>
						</div>
					</div>
					<div class="evosteditor_footer">
						<a class='evo_admin_btn btn_prime evost_save_seating_changes' data-product_id='<?php echo $wooproduct_id;?>' data-eid='<?php echo $eventid;?>'><?php _e('Save Changes','eventon');?></a>
					</div>
					<?php
				$output = ob_get_clean();
				global $ajde;

				$CLASSNAMES = array();
				foreach(array('map_area', 'seat_size') as $item){
					if(!empty($SEATSETTINGS[$item])){
						$CLASSNAMES[] = $item . $SEATSETTINGS[$item];
					}
				}

				$CLASSNM = ( sizeof($CLASSNAMES)>0? implode(' ', $CLASSNAMES) : '');

				echo $ajde->wp_admin->lightbox_content(array(
					'class'=>'evost_lightbox '.$CLASSNM, 
					'content'=>$output, 
					'title'=>__('Seat Map Editor for Event','eventon'), 
					'max_height'=>500,
					'outside_click'=>false
				));
			}

		// save fields
			function event_ticket_save($array){
				$array[] = '_enable_seat_chart';
				return $array;
			}
}
new evost_meta_boxes();	
	