<?php
/** 
 * EVOST - ajax
 * @version 0.1
 */
class EVOST_ajax{
	public function __construct(){
		$ajax_events = array(
			'evost_get_seat_layout'=>'evost_get_seat_layout',
			'evost_add_seat_to_cart'=>'evost_add_seat_to_cart',
			'evost_remove_seat_from_cart'=>'evost_remove_seat_from_cart',
			'evost_get_yourtickets'=>'evost_get_yourtickets',
		);
		foreach ( $ajax_events as $ajax_event => $class ) {				
			add_action( 'wp_ajax_'.  $ajax_event, array( $this, $class ) );
			add_action( 'wp_ajax_nopriv_'.  $ajax_event, array( $this, $class ) );
		}
	}

	// get seat floor layout for lightbox
		function evost_get_seat_layout(){

			global $evost;

			$sections = get_post_meta($_POST['eventid'], '_evost_sections', true);
			$settings = get_post_meta($_POST['eventid'], '_evost_settings', true);
			//print_r($settings);

			$CLASSNAMES = array();
			foreach(array('map_area', 'seat_size') as $item){
				if(!empty($settings[$item])){
					$CLASSNAMES[] = $item . $settings[$item];
				}
			}

			$WIDTH = !empty($settings['map_area'])? explode('-', $settings['map_area']): false;
			$WIDTH = $WIDTH? $WIDTH[0]:650;
			
			$content = '';
			$content = $evost->fn->get_seat_selector_view($sections, $settings, $_POST['eventid'], $_POST['pid']);		

			echo json_encode(array(
				'content'=>$content,
				'status'=>'good',
				'classnames'=> ( sizeof($CLASSNAMES)>0? implode(' ', $CLASSNAMES) : ''),
				'width'=>$WIDTH
			));
			exit;
		}

	// add the selected seat to cart
		function evost_add_seat_to_cart(){
			global $evost; $status = true;

			$sections = get_post_meta($_POST['eventid'], '_evost_sections', true);
			$seat = explode('-', $_POST['seatid']);

			$is_seat_available = $evost->fn->is_seat_available($_POST['seatid'], $_POST['eventid']);

			if($is_seat_available){
				$seat_data = $sections[$seat[0]] ['rows'] [$seat[1]][$seat[2]];
		
				$cart_item_data = array(
					'evost_price' => $seat_data['price'],
					'evost_seatid'=>$_POST['seatid'],
					'evost_eventid'=>$_POST['eventid'],
				);
				
				$cart_item_key = WC()->cart->add_to_cart(
					$_POST['product_id'],
					1,0,array(),
					$cart_item_data
				);

				// if successfully added to cart
				if($cart_item_key){
					// make seat unavailable for others also set expiration time for seat
					$evost->fn->update_seat_status($_POST['eventid'], $_POST['seatid'], 'tuav');
					$evost->fn->update_seat_expiration_time( $_POST['eventid'], $_POST['seatid']);	

					$evost->fn->add_seat_to_cart_session($cart_item_key, $_POST['seatid'],$_POST['eventid']);
					$msg = __('Seat successfully added to cart!','eventon');

					//update_post_meta(1,'aa',$_POST['seatid'].' '.$evost->fn->seat_expiration_time().' '.time() );

				}else{ 
					$msg = __('Seat could not be added to cart, please try later!','eventon');
					$status = false;
				}
			}else{
				$msg = __('Seat not available at the moment','eventon');
				$status = false;
			}

			// get updated your tickets section
			$your_ticket_section = $evost->fn->get_your_tickets_html($_POST['product_id'], $_POST['eventid']);

			// get updated seat map
			$sections = get_post_meta($_POST['eventid'], '_evost_sections', true);
			$seat_map_section = $evost->fn->get_section_html($sections, '', $_POST['product_id'], $_POST['eventid']);

			echo json_encode(array(
				'content'=>$your_ticket_section,
				'seat_map'=>$seat_map_section,
				'status'=> ($status?'good':'bad'),
				'message'=> (!empty($msg)? $msg: null),
			));
			exit;

		}

	// remove the selected seat from cart
	function evost_remove_seat_from_cart(){
		global $evost; $status = true;

		$removed = WC()->cart->remove_cart_item($_POST['key']);

		// if removed completly
		if($removed){
			$msg = __('Seat successfully removed from cart!','eventon');
		}else{
			$msg = __('Seat could not be removed from cart, please try later!','eventon');
			$status = false;
		}

		$sections = get_post_meta($_POST['eventid'], '_evost_sections', true);
		$your_ticket_section = $evost->fn->get_your_tickets_html($_POST['product_id'], $_POST['eventid']);
		$seat_map_section = $evost->fn->get_section_html($sections, '', $_POST['product_id'], $_POST['eventid']);
			

		echo json_encode(array(
			'content'=>$your_ticket_section,
			'seat_map'=>$seat_map_section,
			'status'=> ($status?'good':'bad'),
			'message'=> (!empty($msg)? $msg: null)
		));
		exit;

	}

	
}
new EVOST_ajax();