<?php
/**
 *  Frontend supporting functions
 *  @version  0.2
 */
class evost_functions{

	// get seat map HTML
	function get_section_html($sections, $type='admin', $product_id, $event_id){		
		if(!is_array($sections)) return false;

		$is_admin = ($type=='admin')? true: false;

		$debug = false;

		//$wc_cart_seats = (!$is_admin) ?$this->get_cart_with_seats( $product_id, $sections): array();
		$wc_cart_seats= (!$is_admin) ?$this->get_cart_seats( $product_id, $sections): array();
		$expirations = get_option('_evost_expiration');

		if($debug){
			print_r($expirations);
			print_r($wc_cart_seats);			
			echo time();
		}

		ob_start();

		foreach($sections as $section){

			if(empty($section['section_index'])) continue;

			$ang = !empty($section['ang'])? $section['ang']:0;

			$section_class_names = array();
			$section_class_names[] = 'evost_section';
			$section_class_names[] = 'turn'.$ang;
			$section_class_names[] = $is_admin?'admin':'fnt';
			?>
			<span id='evost_section_<?php echo $section['section_index'];?>' class="<?php echo implode(' ', $section_class_names);?>" data-ang='<?php echo $ang;?>' data-index='<?php echo $section['section_index'];?>' data-rows='<?php echo $section['row_count'];?>' data-name='<?php echo $section['section_name'];?>' style='top:<?php echo $section['top'];?>px;left:<?php echo $section['left'];?>px;'>
				<?php if($is_admin):?><em class='fa fa-bars'></em><?php endif;?>
				
				<u><?php echo $section['section_name'];?></u>
				<?php	foreach($section['rows'] as $row_index=>$row):	?>
				
				<span class="evost_row" data-index='<?php echo $row['row_index'];?>' data-row-name='<?php echo $row['row_index'];?>' data-price='<?php echo $row['row_price'];?>'>
					<?php /*<i><?php echo $row['row_index'];?></i> */?>
					<?php
						$s_num = 1;
						foreach($row as $key=>$seat):
						
						if(in_array($key, array('row_index','row_price'))) continue;

						$seatid = $section['section_index'].'-'.$row_index.'-'.$key;
						$seat_status = (!empty($wc_cart_seats['seatids']) && in_array($seatid, $wc_cart_seats['seatids']))? 'selected'.' '.$seat['status']:$seat['status'];

						// all temp unavailable seats
						if($seat['status'] == 'tuav' ){

							// if the seat in cart - run check
							if(isset($wc_cart_seats[$seatid])){
								$status = $this->run_seat_expiration_check($wc_cart_seats[$seatid], $event_id, $seatid, $expirations);
								if($status == 'removed'){
									$this->update_seat_status($event_id, $seatid, 'av');
									$seat_status = 'av';
								}
							}else{
								$this->update_seat_status($event_id, $seatid, 'av');
								$seat_status = 'av';
							}
						}


						$seat_number = $section['section_index'].$row['row_index'].$s_num;
						$handicap = !empty($seat['handicap']) && $seat['handicap']=='yes'?' hand':'';

						$attributes = '';
						foreach(array(
							'id'=> $section['section_index'].$row['row_index'].$s_num,
							'class'=> 'seat '.$seat_status. $handicap,		
							'data-price'	=> $seat['price'],
							'data-seatid' 	=> $seatid,
							'data-snumber' 	=> $seat_number,
							'data-seat'		=> $s_num,
							'data-row'		=> $row['row_index'],
							'data-section'	=> $section['section_index'],
							'data-orderid'	=> (!empty($seat['order_id'])? $seat['order_id']:'')
						) as $field=>$val){

							// fields to skip for admin
							if(!$is_admin && in_array($field, array(
								'data-orderid'
							))) continue;

							$attributes .= $field .'="'. $val .'"';
						}

						?>
						<span <?php echo $attributes;?>>
							<span class='data'>
								<span>Sec <?php echo $section['section_index'];?>, Row <?php echo $row['row_index'];?>, Seat <?php echo $seat_number;?></span>
								<?php if($seat_status=='av' || $seat_status =='selected'):?>
								<span class='price'>
									<span>Ticket Price</span> 
									<span>$<?php echo $seat['price'];?></span>
								</span>
								<?php endif;?>
							</span>
						</span>
						<?php $s_num++; 

						endforeach;?>
				</span>
				<?php endforeach;?>
								
									
			</span>
			<?php

			update_post_meta($event_id, '_evost_expiration', $expirations);
		}

		return ob_get_clean();
	}

	// get seat selector view
		function get_seat_selector_view($sections, $settings, $event_id, $product_id){
			ob_start();

			global $evost;

			// image
			$img = !empty($settings['seat_bg_img_id'])? 
				wp_get_attachment_image_src($settings['seat_bg_img_id'], 'full'): false;
			
			?>
			<div class='evost_seat_selection' data-currency='<?php echo get_woocommerce_currency_symbol();?>' data-event_id='<?php echo $event_id;?>' data-product_id='<?php echo $product_id;?>'>
				<div class='evost_tooltip'>
					<div class="evost_tt_content">
						<div class="evost_ttc_data section"><span class="label"><?php evo_lang_e('SEC');?></span><span class="value sectionvalue"></span></div>
						<div class="evost_ttc_data row"><span class="label"><?php evo_lang_e('ROW');?></span><span class="value rowvalue"></span></div>
						<div class="evost_ttc_data seat"><span class="label"><?php evo_lang_e('SEAT');?></span><span class="value seatvalue"></span></div>
					</div>
					<div class="evost_section_information">
						<span></span><span class="icon"></span>
					</div>
					<div class="evost_tt_data">
						<span class="label"><?php evo_lang_e('Ticket Price');?></span><span class="price"></span>
					</div>
				</div>
				<div class="evost_seat_legends">
					<span class='av'><b></b> <?php evo_lang_e('Available');?></span>
					<span class='uav'><b></b> <?php evo_lang_e('Unavailable');?></span>
					<span class='cart'><b></b> <?php evo_lang_e('Your selected seats');?></span>
					<span class='res'><b></b> <?php evo_lang_e('Reserved');?></span>
					<span class='hand'><b></b> <?php evo_lang_e('Handicap Accessible');?></span>
				</div>
				<div class='evost_seat_layout' <?php echo $img? 'style="background-image:url('.$img[0].')"':'';?>>
				<?php 
				// seat section
				echo $this->get_section_html($sections, 'front', $product_id, $event_id);

				?>
				</div>
			<div class="evost_selected_seats">
				<p class='evost_msg'></p>
				<div class='evost_selected_seats_in'>
				<?php echo $this->get_your_tickets_html($product_id, $event_id);?>
				</div>
			</div>
			<div class="evost_seats_footer">
			<?php
				$expiration = !empty($evost->frontend->opt_tx['evost_session_time'])? 
					$evost->frontend->opt_tx['evost_session_time']  : false;
				if($expiration):
					$string = str_replace('[time]', $expiration, evo_lang('Seats added to cart will expire in [time] minutes of inactivity in cart.'));
			?>
				<p><?php echo $string;?></p>
			<?php endif;?>
			</div>
			</div>
			<?php
			return ob_get_clean();
		}

	// get a tickets html
		function get_your_tickets_html($product_id, $event_id){

			$sections = get_post_meta($event_id, '_evost_sections', true);

			$your_tickets = $this->get_cart_with_seats($product_id, $sections);

			if(sizeof($your_tickets)==0) return false;

			ob_start();
			?>
			<p class="evost_tix_title"><?php evo_lang_e('Your Tickets');?></p>				
			<ul>
			<?php 

			$seats = 0;
			foreach($your_tickets as $key=>$val):
				if(empty($val) || $key=='total' || empty($val['seat']) ) continue;
			?>
				<li id='<?php echo $key;?>' data-seatid='<?php echo $val['seatid'];?>'>
					<span class="evost_remove_tix">x</span>
					<div class="evost_tix_stub_content" style="display:block">
						<div class="evost_tt_content">
							<div class="evost_ttc_data section"><span class="label"><?php evo_lang_e('SEC');?></span><span class="value sectionvalue"><?php echo $val['seat']['section'];?></span></div>
							<div class="evost_ttc_data row"><span class="label"><?php evo_lang_e('ROW');?></span><span class="value rowvalue"><?php echo $val['seat']['row'];?></span></div>
							<div class="evost_ttc_data seat"><span class="label"><?php evo_lang_e('SEAT');?></span><span class="value seatvalue"><?php echo $val['seat']['seat'];?></span></div>
						</div>
						<div class="evost_tt_data">
							<span class="label"><?php evo_lang_e('Ticket Price');?></span><span class="price"><?php echo get_woocommerce_currency_symbol();?><?php echo $val['seat']['price'];?></span>
						</div>
					</div>
				</li>
			<?php 
				$seats++;
				endforeach;
			?>
			</ul>
			<div class="evost_stub_action">
				<span class='count'><?php echo $seats .' '. ($seats>1? evo_lang('Seat') : evo_lang('Seats'));?></span>
				<span class="action"><a class="evcal_btn" href='<?php echo WC()->cart->get_cart_url();?>'><?php evo_lang_e('Buy Now');?></a></span>
			</div>
			<?php


			return ob_get_clean();
		}

	// Get the WC cart content with seats only
		function get_cart_with_seats($product_id, $sections){
			$total = 0;
			$your_tickets = array();

			foreach ( WC()->cart->get_cart() as $cart_item_key => $values ) {

				$_product = $values['data'];
				//print_r($values);

				if(empty($values['evost_seatid'])) continue;
				if($values['product_id'] != $product_id) continue; // show only seats for this event

				$seat_readable = $this->get_seat_readable_from_id($sections, $values['evost_seatid']);
				
				$your_tickets[$cart_item_key]['seatid'] = $values['evost_seatid'];
				$your_tickets[$cart_item_key]['total'] = $values['line_total'];
				$your_tickets[$cart_item_key]['subtotal'] = $values['line_subtotal'];
				$your_tickets[$cart_item_key]['seat'] = $seat_readable;

				$total += (int)$values['line_subtotal'];
				$your_tickets['seatids'][] = $values['evost_seatid'];

			}

			if($total>0) $your_tickets['total'] = $total;

			return $your_tickets;
		}

		function get_cart_seats($product_id, $sections){
			$your_tickets = array();

			foreach ( WC()->cart->get_cart() as $cart_item_key => $values ) {
				if(empty($values['evost_seatid'])) continue;
				if($values['product_id'] != $product_id) continue; // show only seats for this event

				$your_tickets['seatids'][] = $values['evost_seatid'];
				$your_tickets[$values['evost_seatid']] = $cart_item_key;
			}
			return $your_tickets;
		}

	// get total count of seats by status
		function get_total_seats($sections){
			$seats_av = 0;
			$seats_uav = 0;

			//print_r($sections);
			if(!empty($sections)){
				foreach($sections as $section){
					if(empty($section['rows'])) continue;

					foreach($section['rows'] as $key=>$row){
						foreach($row as $seat){
							if(!is_array($seat)) continue;

							if($seat['status']=='av'){
								$seats_av +=1;
							}else{
								$seats_uav +=1;
							}
						}
					}
				}
			}
			return array('av'=>$seats_av, 'uav'=>$seats_uav);
		}

		// sync the total stock with products stock and available seats value
		function sync_total_available_seats($product_id, $event_id){
			$sections = get_post_meta($event_id, '_evost_sections', true);
			$total_available_seats = $this->get_total_seats($sections);

			$product_stock = get_post_meta($product_id, '_stock',true);

			if($total_available_seats != $product_stock)
				update_post_meta($product_id, '_stock',$total_available_seats);
		}

	// get the price of a seat by seat id
		function get_seat_data_by_id($sections, $seat_id){
			$seat = explode('-', $seat_id);

			return !empty($section[$seat[0]][$seat[1]][$seat[2]])?
				$section[$seat[0]][$seat[1]][$seat[2]]: 
				false;
		}

		function get_seat_number_fromid($seat_id, $event_id){
			$seat = explode('-', $seat_id);

			$sections = get_post_meta($event_id, '_evost_sections', true);

			return !empty($sections[ $seat[0]] ['rows'] [$seat[1]] [$seat[2]]['id'])?
				$sections[ $seat[0]] ['rows'] [$seat[1]] [$seat[2]]['id']: 
				$seat_id;

		}

		// get readable seat info from seat ID
		function get_seat_readable_from_id($sections,$seat_id){
			$seat = explode('-', $seat_id);
			$readable = array();

			$readable['section'] = $seat[0];
			$readable['section_name'] = $sections[$seat[0]]['section_name'];
			$readable['row'] = $sections[$seat[0]] ['rows'] [$seat[1]] ['row_index'];
			$readable['seat'] = $seat[2];
			$readable['price'] = $sections[$seat[0]]['rows'][$seat[1]][$seat[2]]['price'];

			return $readable;
		}

	// update seat status
		function update_seat_status($event_id, $seat_id, $status){
			$seat = explode('-', $seat_id);
			$sections = get_post_meta($event_id, '_evost_sections', true);

			if(!empty( $sections[$seat[0]]['rows'][$seat[1]][$seat[2]]['status'] )){
				$sections[$seat[0]]['rows'][$seat[1]][$seat[2]]['status'] = $status;
			}

			update_post_meta($event_id, '_evost_sections', $sections);
		}

	// update seat field
		function update_seat_field($event_id, $seat_id, $field, $value=''){
			$seat = explode('-', $seat_id);
			$sections = get_post_meta($event_id, '_evost_sections', true);

			if(empty($value)){
				unset($sections[$seat[0]]['rows'][$seat[1]][$seat[2]][$field]);
			}else{
				$sections[$seat[0]]['rows'][$seat[1]][$seat[2]][$field] = $value;
			}			

			update_post_meta($event_id, '_evost_sections', $sections);
		}

	// check if seat is available
		function is_seat_available($seat_id, $event_id){
			$sections = get_post_meta($event_id, '_evost_sections', true);
			if(empty($sections)) return false;

			$seat = explode('-', $seat_id);

			if(empty( $sections[$seat[0]]['rows'][$seat[1]][$seat[2]]['status']) ) return false;

			if( $sections[$seat[0]]['rows'][$seat[1]][$seat[2]]['status'] == 'av') return true; 

			return false;
		}

	// add seat to cart session
		function add_seat_to_cart_session($cart_item_key, $seat_id, $event_id){
			$data = (array)WC()->session->get( '_evost_seat_data' );
			if ( empty( $data[$cart_item_key] ) ) {
				$data[$cart_item_key] = array();
			}
			$data[$cart_item_key] = array($seat_id, $event_id);
			WC()->session->set( '_evost_seat_data', $data );
		}

// Temporary added seats
	function update_seat_expiration_time($event_id, $seat_id){

		$expirations = get_option('_evost_expiration');
		$expirations[$event_id][$seat_id] = $this->seat_expiration_time();

		update_option('_evost_expiration', $expirations);

	}

	function get_seat_expiration_time($event_id, $seat_id, $options=''){
		$expirations = empty($options)? get_option('_evost_expiration'):$options;
		$seat_expiration_time = !empty($expirations[$event_id][$seat_id])? $expirations[$event_id][$seat_id]:false;
		return $seat_expiration_time;
	}
	

	function run_seat_expiration_check($cart_item_key, $event_id, $seat_id, $options=''){
		
		$expirations = empty($options)? get_option('_evost_expiration'):$options;
		
		// get seat expiration time
		$seat_expiration_time = $this->get_seat_expiration_time($event_id, $seat_id, $expirations);

		$status = '';
		// if time expired remove seat from cart
		if($seat_expiration_time && ($seat_expiration_time < time()) ){

			// make the seat available for others to buy
			$this->update_seat_status($event_id, $seat_id, 'av');

			//update_post_meta(1,'aaa',$seat_id.' '.$seat_expiration_time. '<'. time());
			//$seat_exp = $this->get_seat_expiration_time($event_id, $seat_id);
			//update_post_meta(1,'aab',$seat_id.' '.$seat_exp );

			WC()->cart->remove_cart_item($cart_item_key);
			wc_add_notice( 'Seat removed from cart, time expired!', 'error' );
			$status = 'removed';
			
			// remove seat info from the expirations data array
			unset($expirations[$event_id][$seat_id]);
			update_option('_evost_expiration', $expirations);

		}else{
		// update expiration time for seat
			$expirations[$event_id][$seat_id] = $this->seat_expiration_time();
			update_option('_evost_expiration', $expirations);
			$status = 'updated';
		}
		return $status;
	}

	// get the seat expiring time in seconds
	function seat_expiration_time(){
		global $evost;

		$addition = !empty($evost->frontend->opt_tx['evost_session_time'])? 
				($evost->frontend->opt_tx['evost_session_time'] * 60 ):
				(10*60);
		return time() + $addition;
	}
	

// Validation and check function
	function is_ticket_sale_active_for_event($event_id){
		$tickets_active = get_post_meta($event_id, 'evotx_tix',true);
		return $tickets_active && $tickets_active=='yes'? true: false;
	}		
}