<?php
/**
 * Event seats tickets addon integration
 *
 * @author 		AJDE
 * @category 	Admin
 * @package 	EventON-st/classes
 * @version     0.1
 */
class evost_tickets{
	
	function __construct(){
		add_filter('evotx_tix_save_field_meta', array($this, 'evo_tix_fields'), 10, 2);
		add_action('eventontx_tix_post_table', array($this, 'evo_tix_table_row'), 10, 2);
		add_action('evotix_confirmation_email_data', array($this, 'seat_info_tix_confirmation_email'), 10, 3);
	}

	// add seat information to evo-tix CPT so that will be saved in evo-tix cpt for easy access
	function evo_tix_fields($array, $item){
		if(!empty($item['seat_id'])) $array['seat_id'] = $item['seat_id'];
		if(!empty($item['Seat-Number'])) $array['Seat-Number'] = $item['Seat-Number'];

		return $array;
	}

	// show ticket seat number information for evo-tix cpt
	function evo_tix_table_row($post_id, $ticketItem_meta){
		if(!empty($ticketItem_meta['Seat-Number'])): ?>
		
		<tr><td><?php _e('Seat Number','eventon');?>: </td>
		<td><?php echo $ticketItem_meta['Seat-Number'][0];?></td></tr>

		<?php endif;
	}

	// Show seat number information for confirmation ticket email
	function seat_info_tix_confirmation_email($ticket_item_id, $ticket_pmv, $styles){
		if(!empty($ticket_pmv['Seat-Number'])):

			global $evost;

			$event_id = $ticket_pmv['_eventid'][0];
			$sections = get_post_meta($event_id, '_evost_sections', true);
			$readable_seat = $evost->fn->get_seat_readable_from_id($sections, $ticket_pmv['seat_id'][0]);

			$readable_seat_info = 
				$ticket_pmv['Seat-Number'][0]. ' - '. 
				evo_lang('Section') . ': '. $readable_seat['section'] . (!empty($readable_seat['section_name'])? ' ('.$readable_seat['section_name'].')':'') .', '. 
				evo_lang('Row') .': '. $readable_seat['row'] .', '.
				evo_lang('Seat') .': '. $readable_seat['seat'] ;
		?>
		
		<div>
			<p style="<?php echo $styles['005'].$styles['pb5'].$styles['pt10'];?>"><?php echo $readable_seat_info;?></p>
			<p style="<?php echo $styles['004'].$styles['pb5'];?>"><?php echo evo_lang( 'Seat Information');?></p>
		</div>
	
		<?php endif;
	}
}
new evost_tickets();