<?php
/**
 * EventON WeeklyView Ajax Handlers
 *
 * Handles ajax functions
 *
 * @author 		AJDE
 * @category 	Core
 * @package 	EventON-WV/ajax/
 * @version     0.1
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
class EVOWV_ajax{
	public function __construct(){
		$ajax_events = array(
			'new_week'=>'EVOWV_new_week',
			'weekupate'=>'process_events_for_week',
			//'the_ajax_wv'=>'evoWV_ajax_events_list',
		);
		foreach ( $ajax_events as $ajax_event => $class ) {				
			add_action( 'wp_ajax_'.  $ajax_event, array( $this, $class ) );
			add_action( 'wp_ajax_nopriv_'.  $ajax_event, array( $this, $class ) );
		}
	}

	// Get new week data
		function EVOWV_new_week(){
			global $eventon_wv;

			$filter = ((isset($_POST['filters']))? $_POST['filters']:null);
			$shortcode = ((isset($_POST['shortcode']))? $_POST['shortcode']:null);
			$shortcode['filters']= $filter;

			$week_increment = (!empty($_POST['week_incre']))? $_POST['week_incre']:'';

			$day_range = $eventon_wv->frontend->get_week_unix_date_range($_POST);
			$shortcode = array_merge($shortcode, array(
				'focus_start_date_range'=>$day_range['start'], 
				'focus_end_date_range'=>$day_range['end'],
				'week_incre'=> $week_increment,
				'cal_id'=>$_POST['cal_id'],
			));

			//print_r($shortcode);

			$cal_data = $eventon_wv->frontend->get_this_weeks_events($shortcode, 'ajax');
			$header_data = $eventon_wv->frontend->week_cal_header('', $shortcode, $cal_data['events'], 'ajax');

			echo json_encode(array(
				'events'=>$cal_data['content'],
				'header'=>$header_data,
				'unix_start'=>$day_range['start'],
				'unix_end'=>$day_range['end'],
				'status'=>'ok'
			));
			exit;
		}

	// Processed passed event list to generate updated week view
		function process_events_for_week(){
			global $eventon_wv; 

			$weekIncrer = (int)$_POST['week_incre'];
			$weekIncre = ($weekIncrer>0? '+'.$weekIncrer: $weekIncrer) .'weeks';

			$shortcode = array(
				'focus_start_date_range'=>$_POST['focus_start_date_range'], 
				'focus_end_date_range'=>$_POST['focus_end_date_range'],
				'week_incre'=> ($weekIncrer>0? '+'.$weekIncrer: $weekIncrer),
				'cal_id'=>$_POST['cal_id'],
			);

			if(empty($_POST['eventsLIST'])){
				echo json_encode(array(
					'header'=>'','status'=>'bad'
				));
				exit;
			}else{
				//print_r($_POST['eventsLIST']);
				$header_data = $eventon_wv->frontend->week_cal_header('', $shortcode, $_POST['eventsLIST'], 'ajax');
				echo json_encode(array(
					'header'=>$header_data,
					'status'=>'ok'
				));
				exit;
			}			
		}

}
new EVOWV_ajax();

?>