<?php
/**
 * Weeklyview Front-end
 * @version 1.0.11
 */
class EVOWV_frontend{
	//public $is_running_wv = false;
	public $events_list;		
	public $current_time;		
	public $start_of_week;
	public $focus_data = array(); // updated data for focus time
	public $focus_month;
	private $shortcode_args;

	public function __construct(){
		global $eventon;
		add_action( 'init', array( $this, 'register_styles_scripts' ) ,15);
		add_action( 'wp_footer', array( $this, 'print_wv_scripts' ) ,15);
		add_action('evo_addon_styles', array($this, 'styles') );
		add_action('eventon_enqueue_scripts', array($this, 'enquque_scripts') );

		add_filter('eventon_calhead_shortcode_args', array($this, 'calhead_shortcode_args'),10,2);

		// inclusion
		add_action('eventon_calendar_header_content',array($this, 'cal_header_addition'), 10, 2);		
		// others
		add_action('evo_cal_footer',array($this, 'calendar_footer'), 10);

		$this->current_time = current_time('timestamp');
		$this->start_of_week = get_option('start_of_week');
		$this->is_running_wv = false;

		// scripts and styles loading into page
			if(has_eventon_shortcode('add_eventon_wv')){
				$this->print_scripts();					
			}

			// conditionally loading method
			add_action( 'eventon_enqueue_styles', array($this,'print_styles' ));
	}
	
	// STYLES		
		function enquque_scripts(){
			$this->print_styles();			
			$this->print_scripts();			
		}
		public function register_styles_scripts(){	

			if(is_admin()) return;

			global $eventon_wv;

			$evOpt = evo_get_options('1');
			if( evo_settings_val('evcal_concat_styles',$evOpt, true))
				wp_register_style( 'evo_wv_styles',$eventon_wv->addon_data['plugin_url'].'/assets/wv_styles.css');
			wp_register_script('evo_wv_ease',$eventon_wv->addon_data['plugin_url'].'/assets/jquery.easing.1.3.js', array('jquery'), 1.0, true );
			//wp_register_script('evo_wv_mobile',$eventon_wv->addon_data['plugin_url'].'/assets/jquery.mobile.min.js', array('jquery'), 1.0, true );
			wp_register_script('evo_wv_script',$eventon_wv->addon_data['plugin_url'].'/assets/wv_script.js', array('jquery'), $eventon_wv->version, true );
			/*wp_localize_script( 'evo_wv_script', 'EVOWV_script',
			    array( 
			        'ajaxurl'   => admin_url( 'admin-ajax.php' ),
			    )
			);*/

		}
		public function print_scripts(){	
			wp_enqueue_script('evo_wv_ease');	
			//wp_enqueue_script('evo_wv_mobile');	
			wp_enqueue_script('evo_wv_script');	
		}

		function print_styles(){
			wp_enqueue_style( 'evo_wv_styles');	
		}
		function print_wv_scripts(){
			global $eventon_wv;
			if($eventon_wv->is_running_wv)
				return;

			$this->print_scripts();
			$eventon_wv->is_running_wv=false;
		}
		function styles(){
			global $eventon_wv;
			ob_start();
			include_once($eventon_wv->plugin_path.'/assets/wv_styles.css');
			echo ob_get_clean();
		}
		
	// cal header arguments
		function calhead_shortcode_args($array, $args){
			if(!isset($args['disable_week_switch'])) return $array;

			$array['disable_week_switch'] = $args['disable_week_switch'];
			return $array;
		}

	// Get Calendar for weekly View
		function get_weekly_view($args){
			$cal =  $this->get_this_weeks_events($args);
			return $cal['content'];
		}

	// get correct week unix date range
		function get_week_unix_date_range($args=''){

			//print_r($args);
			// current month data
				//$current_timestamp = strtotime('2017-12-31');
				//$this->current_time = $current_timestamp;
				$current_timestamp =  $this->current_time;

				$a_week_seconds = 7*24*3600;

			// increments for focus month adjusting
				$month_incre = (!empty($args['month_incre']))?$args['month_incre']:0;
				$day_incre = (!empty($args['day_incre']))?$args['day_incre']:0;	

			// fixed week, month, year values
				if(!empty($args['fixed_week']) && !empty($args['fixed_month']) && !empty($args['fixed_year'])){
					$week_start_range = strtotime("{$args['fixed_year']}-{$args['fixed_month']}-1 +{$args['fixed_week']} week");
						$week_start = explode('-', date('Y-n-j',$week_start_range));

					return array(
						'start'=>$week_start_range,
						'end'=> (int)$week_start_range+$a_week_seconds,
						'week_start'=>$week_start
					);

				}

			// current focused values			
			// current week
				$week_increment = (!empty($args['week_incre']))? ' '.$args['week_incre'].'weeks':'';

				// today day of the week
				$today_day = date('w', $current_timestamp); // sun = 0, sat = 6
				
				// general start of the week day num
				$start_ow = $this->start_of_week; // sun = 0, mon = 1, sat = 6

				if( $start_ow >1) $dayDif = $today_day -( $start_ow-1);
				if( $today_day > $start_ow ) $dayDif = $today_day - $start_ow;
				if( $today_day == $start_ow ) $dayDif = 0;
				if( $start_ow > $today_day) $dayDif = 7 - $start_ow;

				// day difference -/+ strings
					$day_addition = ($dayDif == 0)?'0 days':'-'.$dayDif.'days';
					$day_addition_end = ($dayDif == 0)? '+'.(6-$dayDif).'days' :'+'.(6-$dayDif).'days';
				
				//echo 'TD'.$today_day.'SOW'.$start_ow.'DA'.$day_addition. $week_increment.'---';

				$week_start = date('Y-n-j', strtotime($day_addition. $week_increment, $current_timestamp));
				$week_end = date('Y-n-j', strtotime($day_addition_end. $week_increment, $current_timestamp));
				//echo $week_end;
					$week_start = explode('-', $week_start);
					$week_end = explode('-', $week_end);

				//print_r($week_start);

				$focus_start_date_range = mktime( 0,0,0, $week_start[1] , $week_start[2] , $week_start[0] );
				$focus_end_date_range = mktime( 23,59,59, $week_end[1] , $week_end[2] , $week_end[0] );

			return array(
				'start'=>$focus_start_date_range,
				'end'=>$focus_end_date_range,
				'week_start'=>$week_start
			);
		}

	// get weeks worth of events
		public function get_this_weeks_events($args, $type='init'){

			$this->is_running_wv = true;
			$this->only_wv_actions('new');	

			$day_range = $this->get_week_unix_date_range($args);


			ob_start();
			
			// Calendar events for the current week
				$new_arguments = array(
					'focus_start_date_range'=>$day_range['start'],
					'focus_end_date_range'=>$day_range['end'],
				);

				global $eventon;

				$args = (!empty($args) && is_array($args))? array_merge($args, $new_arguments): $new_arguments;	

				$args__ = $eventon->evo_generator->process_arguments($args, true);
				$this->shortcode_args=$args__;

				$lang = (!empty($shortcode['lang']))? $shortcode['lang']: null;
				$this->set_three_letter_day_names($lang);

				$EVENTSlist = $this->events_list = $eventon->evo_generator->evo_get_wp_events_array('', $args__, $args['filters']);

				$date_range_events_array = $eventon->evo_generator->generate_event_data( 
					$EVENTSlist, 
					$day_range['start'],
					$day_range['week_start'][1] , 
					$day_range['week_start'][0] 
				);

				if($type=='init'){
					$rtl = $eventon->evo_generator->body->rtl;

					// calendar section header
					echo $eventon->evo_generator->body->get_calendar_header(array(
						'focused_month_num'=>$day_range['week_start'][1], 
						'focused_year'=>$day_range['week_start'][0], 
						'sortbar'=>true, 
						'date_header'=>false,
						'range_start'=>$day_range['start'],
						'range_end'=>$day_range['end'],
						'send_unix'=>1,
						'_html_evcal_list'=>false
						)
					);

					$extra_class = ($type=='init' && evo_settings_val('hide_events_onload',$args))? 'evowv_hide':'';
					echo "<div id='evcal_list' class='eventon_events_list tester {$rtl} ".($extra_class)."'>";
				}
				echo $eventon->evo_generator->evo_process_event_list_data($date_range_events_array, $args__);

				// hide all events on initial load
				if( evo_settings_val('hide_events_onload',$args)){
					echo "<div class='eventon_list_event evowv_click_notice'><p class='no_events'>".evo_lang('Click on Date to see events')."</p></div>";
				}

				if($type=='init') echo $eventon->evo_generator->body->calendar_shell_footer();

			$this->is_running_wv = false;
			$this->remove_only_wv_actions('new');

			return array('content'=>ob_get_clean(), 'events'=>$EVENTSlist);
		}

	// calendar week header
		function cal_header_addition($content, $args){				
			echo $this->week_cal_header($content, $args);
		}

		function week_cal_header($content, $args, $eventList = '', $type=''){

			if($this->is_running_wv || $type=='ajax'){

				$lang = (!empty($args['lang']))? $args['lang']: 'L1';
				$this->set_three_letter_day_names($lang);
			//print_r($args);
			
			$start = date('Y-n-j-z-t-w', (int)$args['focus_start_date_range']);
				$start = explode('-', $start);
			$end = date('Y-n-j-z-t-w', (int)$args['focus_end_date_range']);
				$end = explode('-', $end);

			$weekIncre = (int)$args['week_incre'];
			$date_format = get_option('date_format');

			ob_start();
			
			$stime = eventon_get_formatted_time($args['focus_start_date_range'], $lang);
			$stime = eventon_get_lang_formatted_timestr($date_format, $stime);
			$etime = eventon_get_formatted_time($args['focus_end_date_range'], $lang);
			$etime = eventon_get_lang_formatted_timestr($date_format, $etime);	
			$txt_noevents = eventon_get_custom_language('','evcal_lang_noeve','No Events',$lang);

			//hide_events_onload

			// previous content
				echo "<div class='EVOWV_content' data-start='".$args['focus_start_date_range']."' data-end='".$args['focus_end_date_range']."' data-week_incre='".$args['week_incre']."' data-txnoevent='{$txt_noevents}'>
					<div class='EVOWV_dates' data-week='{$weekIncre}'><p class='EVOWV_thisdates_range'><em>". $stime ."</em> - <em>". $etime ."</em></p>";
				
				if(isset($args['disable_week_switch']) && $args['disable_week_switch']=='no'){
					echo "<div class='EVOWV_change'><i class='fa fa-sort'></i>";
						echo "<div class='EVOWV_ranger'>";
						echo "<a class='EVOWV_range_mover up'><i class='fa fa-angle-up'></i></a>";
						echo "<div class='EVOWV_ranger_handle'>";
						echo "<ul class='EVOWV_date_ranges' style='top:-300px'>";
						echo $this->get_range($args['focus_start_date_range'], $args['focus_end_date_range'], $date_format, $weekIncre, $lang);
						echo "</ul>";
						echo "</div>";
						echo "<a class='EVOWV_range_mover down'><i class='fa fa-angle-down'></i></a>";
						echo "</div></div>";
					
				}	

				$disable_week_switch = (isset($args['disable_week_switch']) && $args['disable_week_switch']=='yes')? true: false;

				echo "</div>";
				echo "<div class='eventon_weeklyview".($disable_week_switch?' dws':'')."' cal_id='{$args['cal_id']}' data-multiplier='0' data-start='' data-end=''>";

				if(!$disable_week_switch){
					echo "<a class='evowv_prev evowv_arrow' data-dir='prev' data-week='". ( $weekIncre-1)."'><i class='fa fa-angle-left'></i></a>
					<a class='evowv_next evowv_arrow' data-dir='next' data-week='". ($weekIncre+1)."'><i class='fa fa-angle-right'></i></a>";
				}

				echo "<div class='evoWV_days' data-focus_week=''>";
				echo "<div class='eventon_wv_days EVOWV'>";
			
			$eventList = (!empty($eventList))? $eventList: $this->events_list;
			$events = $this->event_list_to_days($eventList, $args['focus_start_date_range'], $args['focus_end_date_range']);

			//print_r($eventList);
			
			// TODAY
				$TODAY = date('Y-n-j-z', $this->current_time);
				$TODAY = explode('-', $TODAY);
						
			//print_r($start);

			// Start and end same year
				// start and end same month
					if( $start[1]== $end[1]){
						$count =0;

						for($x = (int)$start[2]; $x<= (int)$end[2]; $x++){
							$dow = ($this->start_of_week ==0)? $count: $count + $this->start_of_week;
							$dow = ($dow>6)? $dow-7:$dow;

							// is this eventon today
							$today = ( $start[1] == $TODAY[1] && $TODAY[2]== $x && $TODAY[0]== $start[0])? true: false;
							echo $this->each_day($x,$start[1],$start[0], $dow,$events, $today);
							$count ++;
						}
					}else{// start and end dif months						
						if($start[2] <= $start[4]){
							$count =0;
							for( $x= $start[2]; $x<=$start[4]; $x++ ){
								$dow = ($this->start_of_week ==0)? $count: $count + $this->start_of_week;
								$dow = ($dow>6)? $dow-7:$dow;

								$today = ( $start[1] == $TODAY[1] && $TODAY[2]== $x && $TODAY[0]== $start[0])? true: false;
								echo $this->each_day($x,$start[1],$start[0], $dow,$events, $today);
								$count ++;
							}
							
							for( $x= 1; $x<=$end[2]; $x++ ){
								$Ustart = date('Y-n', ((int)$args['focus_start_date_range'])+ (86430*$count) );
								$Ustart = explode('-', $Ustart);					
								
								$today = ( $TODAY[2]== $x && $TODAY[1]== $Ustart[1] && $TODAY[0]== $Ustart[0])? true: false;
								$dow = ($this->start_of_week ==0)? $count: $count + $this->start_of_week;
								$dow = ($dow>6)? $dow-7:$dow;	
								echo $this->each_day($x,$Ustart[1],$Ustart[0], $dow,$events, $today);
								$count ++;
							}
						}
					}

				
			echo "<div class='clear'></div>";
			echo "</div>";
			echo "</div>";	
			echo "</div>";	
			echo "</div>";	

			// /echo 'tt'.$start.' '.$end;
			return ob_get_clean();
			}
		}

	// HTML: for each day box in the week strip
		function each_day($day, $month, $year, $dayofweek, $events, $today=false){
			
			$events_for_day = (!empty($events[0][$day]))? $events[0][$day]: false;

			// days event count elements
				$innerItems = '';
				if($events_for_day>0){
					$json = $events[1][$day];
					switch($events_for_day){
						case 1: $innerItems= "<em class='dayTag' data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em>"; break;
						case 2: $innerItems= "<em class='dayTag' data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em><em class='dayTag' data-title='".$json['et'][1]."' style='background-color:#{$json['ec'][1]}'></em>"; break;
						case 3: $innerItems= "<em class='dayTag' data-title='".$json['et'][0]."' style='background-color:#{$json['ec'][0]}'></em>
							<em class='dayTag' data-title='".$json['et'][1]."' style='background-color:#{$json['ec'][1]}'></em>
							<em class='dayTag' data-title='".$json['et'][2]."' style='background-color:#{$json['ec'][2]}'></em>"; break;
						case ($events_for_day>3): $innerItems= "<em class='dayTag more' data-title='".$events_for_day."+'></em>"; break;
					}
				}

			//$dayofweek = $dayofweek+1;

			$content ="<div class='evo_wv_day ".( $today? 'today':'')."' data-day='{$day}' data-date='{$year}-{$month}-{$day}' data-events='". (isset($json['ei'])? json_encode($json['ei']): 'no')."'>"
					.'<span class="day_name">'.$this->day_names[$dayofweek].'</span>'
					.'<span class="day_num">'.($day)."</span>
					<span class='day_events'>".$innerItems."</span>"."</div>";
			return $content;
		}

	// HTML: week range selection options
		function get_range($start, $end, $dateFormat, $week, $lang=''){
			$weekSeconds = 604800;

			$date_format = 'M d, Y';

			$html = ''; $count = 0;
			for($x=-12; $x<=12; $x++){
				$st = (int)$start + ($x*$weekSeconds);
				$et = (int)$end + ($x*$weekSeconds);

				$stime = eventon_get_formatted_time($st, $lang);
				$stime = eventon_get_lang_formatted_timestr($date_format, $stime);
				$etime = eventon_get_formatted_time($et, $lang);
				$etime = eventon_get_lang_formatted_timestr($date_format, $etime);
				
				$thisweek = $x+$week;
				$html .= "<li class='".(($thisweek == $week)?'thisweek':'')."' data-index='{$count}' data-week='".($thisweek)."' style='display:". (($x>-3 && $x<3)?'block':'')."'><em>". $stime. '</em> - <em>'.
					$etime. "</em></li>";
				$count ++;
			}
			return $html;
		}
	// Filter event list into days
		function event_list_to_days($event_list_array, $startDayWeek, $endDayWeek, $daystocountfor=7, $month=''){
			$date_with_events= $days_w_e = array();
		
			// Week range
			$week_start_date_of_year = date('z', $startDayWeek);
			$week_end_date_of_year = date('z', $endDayWeek);


			if(is_array($event_list_array) && count($event_list_array)>0){	

				foreach($event_list_array as $event){

					// Check for month and year long events
						$_is_all_year = (!empty($event['event_pmv']['evo_year_long']) && $event['event_pmv']['evo_year_long'][0]=='yes')? true:false;
						$_is_all_month = $_is_all_year? false: ((!empty($event['event_pmv']['_evo_month_long']) && $event['event_pmv']['_evo_month_long'][0]=='yes')? true:false );

					$__duration='';
					$__dur_type ='';

					$start_unix = $event['event_start_unix'];
					$end_unix = $event['event_start_unix'];		

					// days for evenr start year
						$days_in_year = date('z',$start_unix);

					// All year or all month events
					if($_is_all_year || $_is_all_month ){
						$__duration= $daystocountfor;
						$start_date = 1;
						$start = $end = array();
					
						if($_is_all_year){

							$start = date('Y', $event['event_start_unix']).'-1-1-0-0'; 
							$end = date('Y', $event['event_start_unix']).'-12-31-0-0'; 

							$start_unix = strtotime($start);
							$end_unix = strtotime($end);
						}		

						if($_is_all_month){

							$start = date('Y-n', $event['event_start_unix']).'-1-0-0'; 
							$end = date('Y-n', $event['event_start_unix']).'-'. date('t', $event['event_start_unix']). '-0-0'; 
						}				
					}else{
						$start = date('Y-n-j-z-t', $event['event_start_unix']); $start = explode('-',$start);
						$end = date('Y-n-j-z-t', $event['event_end_unix']); $end = explode('-',$end);

						// days for evenr start year
							$days_in_year = date('z',mktime(0,0,0,12,31,$start[0]));

						// Same year
						if($start[0] == $end[0]){
							// same month
							if($start[1] == $end[1]){
								// same date
								if($start[2] == $end[2]){
									$__no_events = (!empty($date_with_events[$start[2]]))?
										$date_with_events[$start[2]]:0;
									
									$date_with_events[$start[2]] = $__no_events+1;

									//$days_w_e[$start_date]['count'] = $__no_events+1;
									$days_w_e[$start[2]]['ei'][] = $event['event_start_unix'].'-'.$event['event_end_unix'];
									$days_w_e[$start[2]]['et'][] = $event['event_title'];
									$days_w_e[$start[2]]['ec'][] = (!empty($event['event_pmv']['evcal_event_color'])? 
										$event['event_pmv']['evcal_event_color'][0]:'');
									
								}else if($start[2]<$end[2]){									
								// different date
									$__duration = $end[3] - $start[3]+1;
								}
							}else{
								$__duration = $end[3] - $start[3] +1;
							}	
						}else{ // different start end year
										
							$__duration = ($days_in_year + $end[3] ) - $start[3] +2;
						}				
					}	

					$start_date = isset($start[2]) ? $start[2]:0;
					
					// run multi-day
					if(!empty($__duration) || $__dur_type=='eom'){

						// End of the week adjust for year end periods
						
						//echo $__duration.' '.$event['event_id'].' '.$start_date;

						$__duration = ($__duration==0 && $__dur_type=='eom')? 1: $__duration;
						
						for($x=0; $x<$__duration; $x++){

							// adjust increment date based on days in month
								$THISdate = $start_date+($x);
									$THISdate = ($THISdate > $start[4])? $THISdate-$start[4]: $THISdate;	
							
							// Get the adjusted start date of the year
								$date_of_year = $start[3] + $x;
								if($date_of_year > $days_in_year) $date_of_year = $date_of_year -$days_in_year;

							// make sure the date is within week range							
							if( $week_start_date_of_year <= $date_of_year && $date_of_year <= $week_end_date_of_year ){

								//echo $THISdate.' ';

								// events on this day
								$__no_events = (!empty($date_with_events[$THISdate]))?	$date_with_events[$THISdate]:0;

								$date_with_events[$THISdate] = $__no_events+1;
								$days_w_e[$THISdate]['ei'][] = $event['event_start_unix'].'-'.$event['event_end_unix'];
								$days_w_e[$THISdate]['et'][] = $event['event_title'];
								$days_w_e[$THISdate]['ec'][] = (!empty($event['event_pmv']['evcal_event_color'])? 
									$event['event_pmv']['evcal_event_color'][0]:'');
							}
							
						}
					}					
				}							
			}

			//print_r($days_w_e);
			return array($date_with_events , $days_w_e);

		}	
	
	// ONLY for WV calendar actions 
		public function only_wv_actions($type=''){
			add_filter('eventon_cal_class', array($this, 'eventon_cal_class'), 10, 1);	
		}
		public function remove_only_wv_actions($type=''){
			remove_filter('eventon_cal_class', array($this, 'eventon_cal_class'));			
		}
	// add class name to calendar header for EM
		function eventon_cal_class($name){
			$name[]='evoWV'; return $name;
		}
	// remove class name to calendar header for EM
		function remove_eventon_cal_class($name){
			if(($key = array_search('evoWV', $name)) !== false) {
			    unset($name[$key]);
			}return $name;
		}

	// three letter day array
		function set_three_letter_day_names($lang=''){
			
			// Build 3 letter day name array to use in the weeklyview from custom language
			for($x=0; $x<=6; $x++){
				$z = $x+1;
				$y = ($z>6)? $z-7: $z;		
				$evcal_day_is[$y] =eventon_return_timely_names_('day_num_to_name',$z, 'three', $lang);
				//print_r($evcal_day_is[$x]);				
			}	
			//print_r($evcal_day_is);
			$this->day_names = $evcal_day_is;
		}
	
		function days_in_month($month, $year) { 
			return date('t', mktime(0, 0, 0, $month+1, 0, $year)); 
		}
		function calendar_footer(){
			$this->is_running_wv=false;
		}

}