<?php
/**
 * EventON WeeklyView Ajax Handlers
 *
 * Handles shortcode functions
 *
 * @author 		AJDE
 * @category 	Core
 * @package 	EventON-WV/shortcode/
 * @version     0.1
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class EVOWV_shortcode{

	static $add_script;

	function __construct(){
		add_shortcode('add_eventon_wv', array($this,'evoWV_generate_calendar'));
		add_filter('eventon_shortcode_popup',array($this,'evoWV_add_shortcode_options'), 10, 1);
	}

	/**	Shortcode processing */	
		function evoWV_generate_calendar($atts){
			global $eventon_wv, $eventon;

			// add fc scripts to footer
			add_action('wp_footer', array($eventon_wv, 'print_scripts'));

			$eventon_wv->is_running_wv=true;
			
			add_filter('eventon_shortcode_defaults', array($this,'evoWV_add_shortcode_defaults'), 10, 1);

			// connect to support arguments
			$supported_defaults = $eventon->evo_generator->get_supported_shortcode_atts();
			
			$args = shortcode_atts( $supported_defaults, $atts ) ;			
			
			ob_start();
				
				echo $eventon_wv->frontend->get_weekly_view($args);
				//echo $eventon_wv->frontend->generate_eventon_wv_calendar($args);
			
			return ob_get_clean();
					
		}

	// add new default shortcode arguments
		function evoWV_add_shortcode_defaults($arr){			
			return array_merge($arr, array(
				'fixed_week'=>0,		
				'week_incre'=>0,		
				'always_first_week'=>'no',		
				'hide_events_onload'=>'no',	
				'disable_week_switch'=>'no',	
				'week_style'=>0,	
			));			
		}

	/*	ADD shortcode buttons to eventON shortcode popup	*/
		function evoWV_add_shortcode_options($shortcode_array){
			global $evo_shortcode_box;
			
			$new_shortcode_array = array(
				array(
					'id'=>'s_WV',
					'name'=>'WeeklyView',
					'code'=>'add_eventon_wv',
					'variables'=>array(
						
						$evo_shortcode_box->shortcode_default_field('show_et_ft_img'),
						$evo_shortcode_box->shortcode_default_field('ft_event_priority'),	
						$evo_shortcode_box->shortcode_default_field('event_type'),
						$evo_shortcode_box->shortcode_default_field('event_type_2'),
						array(
							'name'=>__('Week Increment','eventon'),
							'type'=>'text',
							'guide'=>'Set + or - week increment from current week of the month to show at first',
							'var'=>'week_incre',
							'default'=>'',
							'placeholder'=>'eg. +1'
						),array(
							'name'=>__('Hide events on first load','eventon'),
							'type'=>'YN',
							'guide'=>'This will hide calendar events until a date on the week strip is clicked by the visitor',
							'var'=>'hide_events_onload',
							'default'=>'no',
						),
						array(
							'name'=>__('Disable Week Switching','eventon'),
							'type'=>'YN',
							'guide'=>'Disable the user ability to switch weeks',
							'var'=>'disable_week_switch',
							'default'=>'no',
						),						
						$evo_shortcode_box->shortcode_default_field('event_order'),
						$evo_shortcode_box->shortcode_default_field('lang'),					
						$evo_shortcode_box->shortcode_default_field('UIX'),					
						$evo_shortcode_box->shortcode_default_field('evc_open'),
						$evo_shortcode_box->shortcode_default_field('etc_override'),
						$evo_shortcode_box->shortcode_default_field('hide_sortO'),
						$evo_shortcode_box->shortcode_default_field('expand_sortO'),
						$evo_shortcode_box->shortcode_default_field('filter_type'),
						$evo_shortcode_box->shortcode_default_field('members_only'),

					)
				)
			);

			return array_merge($shortcode_array, $new_shortcode_array);
		}
}
?>